#!/usr/bin/env python3.6-64
from DataObject import DataObject # Object that will hold all relevent data
from PipelineOrganizer import PipelineOrganizer as _PO
from DataHandler import DataHandler as _DH
from DataPathHandler import DataPathHandler

from PlotLibrary import TrajPlots as _TrajPlots
#from PlotLibrary import RawDataPlot as _RawDataPlot

def main():
    # Path prefix for local data storage
    # prefix = "/proj/uppstore2018129/elflab/Projects/Shadowfax/Data"
    # prefix = "C:/Users/bobro/Documents/ShadowDev/Data"
    prefix = "C:/Users/elias/Desktop/Shadowfax/Data"
    
    # Define path where the data is stored  
    
    pathnames = ['/20201201_(20201120_PSF)_MJ655(70%high~0.6mu2s)/0-Bead/' ,  #0
                 '/20201201_(20201120_PSF)_MJ655(70%high~0.6mu2s)/8_cells_MJ1655-oASD/' ,  #1
                 '/20201208_PSF_and_CellTracking_with_markers/6_cells-MJ364/', #2
                 '/20201210_PSF_bead_z-_power_weights_onglass/0_Bead_with_power_weights/', #3
                 '/20210114_PSF_Bead_rotation_with_weights/Bead_20nm_SpinAgarose_106_94_Rotating_xy0.3_zp2p0.33/', #4
                 '/20201215_PSF_glycerol_JF549Halo/2_614pM-JF549Halo_90percentWeight-glycerol_100percent-power/', #5
                 '/20201218_PSF_glycerol_JF549Halo/1_85.94percentWeight-glycerol_1nM-JF549Halo_100percent-power/', #6
                 '/20210216_xy_1khz_0.5kz_overlaySignal/3_50mW-PID_-0.0119629-1-1_a0.5_Bead_20nm_SpinAgarose_Rotating_xyEODF1k0.5kA2.5(p2p5)A5(p2p10)/',#7
                 '/20210217_Laser_Modulation/50mW-Bead_20nm_SpinAgarose_yyzxxz_sitting-still/',    #8
                 '/20210226_GlyserolTracking/90percent/240mW-90percent-wbw-1nM-JF549_minflux/',                      #9
                 '/20210302_GlyserolTracking/240mW-99percent-wbw-2nM-JF549_minflux/',       #10
                 '/20210319_PSF_CellTracking_TriggerFactor/data/240mW_trigger-factor-9/',   #11
                 '/20210401/TF_mutant_40us-integration/240mW_TF-mutant_MJ375-1/',           #12   
                 '/20210401/ribosome_40us-integration/240mW-ribosome_MJ196-2/',             #13 use 2,3,4,6,7,8,9a,9b,10,11,12a,12b,13
                 '/20210326/240mW-99.8percent-wbw-200pM-JF549_40us-integration-time/',      #14
                ]
    
    
    for Project_Folder in [13]:
        loadSaveData=1  #if 1 load saved data, if 0 do not load (re-calculate)

        data_path_handler= DataPathHandler(prefix,pathnames)
        data_path_handler.get_data_paths() # pathes are stored in, data_path_handler.Files
    
        DataHandler=_DH() #Class object that can process data 
        ScanProject = DataObject(data_path_handler, Project_Folder,loadSaveData) #Class object that stores all data for a given scan
        ScanProject=_PO.DataPipline(ScanProject,DataHandler) 
    
        ## Plot
        #ScanProject.SavePlot=0
        #PTraj=_TrajPlots()
        #PTraj.plot_trajectory(ScanProject)
        #PTraj.plot_trajectory_MSD(ScanProject)
        
        print("Done!")


if __name__ == '__main__':
    main()

