from DataObject import DataObject # Object that will hold all relevent data
from PipelineOrganizer import PipelineOrganizer as _PO
from DataHandler import DataHandler as _DH
from DataPathHandler import DataPathHandler
from PSF_Lib import PSF_Lib as _PSF
from Physics_Lib import Particle as _Particle
from Physics_Lib import physics_Lib as _PhLib
from PlotLibrary import TrajPlots as _TP
from Simulator import Simulator as _Sim
from miscellaneous import miscellaneous as _MI
from HMM import HMM_Traj as _HMM

import scipy.io as io
import numpy as np
import scipy.stats as stats    

from mpl_toolkits.mplot3d import Axes3D
import matplotlib
import matplotlib.pyplot as plt
import matplotlib.cm as cm
import mpl_toolkits.mplot3d.axes3d as p3
from matplotlib.gridspec import GridSpec
import scipy as sp
import scipy.interpolate
from scipy.interpolate import RegularGridInterpolator

#import tensorflow.compat.v2 as tf
#tf.enable_v2_behavior()
#import tensorflow_probability as tfp
#from tensorflow_probability import distributions as tfd



def main1():
    
    #1. Generate data:
    #   Laser shot posisions (Need S matrix for this)
    #   Generat mean Photon  
    #   Generate Poisson photon statistics
    #   Generate offset vektor 
    #   Generate zlevel used   
    #
    #2. Generate Scan matrix 
    #   See: get_traj_raw_data2 for all scan data needed to be generated
    #   Everything else is mostlikly from the ini file 
    

    #Get ini file for system definition
    prefix = "C:/Users/elias/Desktop/Shadowfax/Data"
    
    pathnames = [
                 '/20200909/Simulation_1/',             #0
                 ]
    
    ProjectToRun=0
    for Project_Folder in [ProjectToRun]:
        #Create a ScanProject
        data_path_handler= DataPathHandler(prefix,pathnames)
        data_path_handler.get_data_paths() # pathes are stored in, data_path_handler.Files

        DataHandler=_DH() #Class object that can process data 
        ScanProject = DataObject(data_path_handler, Project_Folder,loadSaveData=0) #Class object that stores all data for a given scan

        #Start a Simulator        
        Sim=_Sim(ScanProject)

        S,xx,yy,zz,XP,YP,XE,YE,XO,YO,ZI,MemIndexTracking=Sim.get_SMatrix(ScanProject)
        P=_PSF.get_ProbFromSmatrix(S)

        for k in range(6):
            for i in range(P.shape[2]):
                fig = plt.figure(constrained_layout=True)
                ax0=fig.add_subplot()
                cs0=ax0.contourf(xx[:,:,i],yy[:,:,i],S[:,:,i,k],levels=np.linspace(0,2**12,100) ) #np.linspace(0,0.9,50) 
                fig.colorbar(cs0,ax=ax0)
        
                save=1
                if save:
                    file="T" + "_pos_" + str(i) + '.png'
                    path="C:/Users/elias/Desktop/Shadowfax/Data/20200909/Simulation_1/S_Dot_" + str(k) + "/"
                    fig.savefig(path + file)
                    plt.close()
                else:
                    plt.show()

        #DataHandler.PickleData(ScanProject,override=0)

def main2():
    
    #1. Generate data:
    #   Laser shot posisions (Need S matrix for this)
    #   Generat mean Photon  
    #   Generate Poisson photon statistics
    #   Generate offset vektor 
    #   Generate zlevel used   
    #
    #2. Generate Scan matrix 
    #   See: get_traj_raw_data2 for all scan data needed to be generated
    #   Everything else is mostlikly from the ini file 
    

    #Get ini file for system definition
    prefix = "C:/Users/elias/Desktop/Shadowfax/Data"
    
    pathnames = [
                 '/20200928_SIM/Simulation_1_R16383_48pointSlow/',             #0
                 ]
    
    ProjectToRun=0
    SRB_step=np.zeros((1,20))
    N=np.zeros(20)
    pointotget=np.array([[40,40,41]])
    for Project_Folder in range(5):
        #Create a ScanProject
        data_path_handler= DataPathHandler(prefix,pathnames)
        data_path_handler.get_data_paths() # pathes are stored in, data_path_handler.Files

        DataHandler=_DH() #Class object that can process data 
        ScanProject = DataObject(data_path_handler, Project_Folder,loadSaveData=0) #Class object that stores all data for a given scan

        #Start a Simulator        
        Sim=_Sim(ScanProject)
        
        S,xx,yy,zz,XP,YP,XE,YE,XO,YO,ZI,MemIndexTracking=Sim.get_SMatrix(ScanProject,p='WeightedTwoWay')
        if np.sum(np.where(S<0))>0:
            print("S negativa")
            S[np.where(S<0)]=0
           
        P=_PSF.get_ProbFromSmatrix(S)
        
        for step in range(20):
            n=(0.01+step/3)*np.array([1,1,1,1,1,1]) #(110,105,70)
            Hx,Hy,Hz=_MI.SobelFeldman3DKernal()
            SqCRBx=Get_CRB(P,xx,Hx,n)
            SqCRBy=Get_CRB(P,yy,Hy,n)
            SqCRBz=Get_CRB(P,zz,Hz,n)
            SqCRB=(SqCRBx+SqCRBy+SqCRBz)/3
            SRB_step[Project_Folder,step]=SqCRB[tuple(pointotget[Project_Folder,:])]
            N[step]=np.sum(n)
            print('CRB: ' + str(SRB_step[Project_Folder,step]) + ' n_tot=' + str(N[step]) )

            if 1:
                for i in range(SqCRB.shape[2]):
                    fig = plt.figure(constrained_layout=True)
                    ax0=fig.add_subplot()
                    cs0=ax0.contourf(SqCRB[:,:,i],levels=np.linspace(0,200,50) ) 
                    fig.colorbar(cs0,ax=ax0)
        
                    save=1
                    if save:
                        file="T" + "_pos_" + str(i) + '_step_' + str(step) + '.png'
                        path= prefix+pathnames[Project_Folder]
                        fig.savefig(path + file)
                        plt.close()
                    else:
                        plt.show()

        fig = plt.figure(constrained_layout=True)
        ax0=fig.add_subplot()
        ax0.plot(N[1:],SRB_step[0,1:],'-*b') 
        ax0.legend(('176nm, (16383)'))
        plt.grid()
        plt.show()
        print("Done!")

def main3():
    
    #1. Generate data:
    #   Laser shot posisions (Need S matrix for this)
    #   Generat mean Photon  
    #   Generate Poisson photon statistics
    #   Generate offset vektor 
    #   Generate zlevel used   
    #
    #2. Generate Scan matrix 
    #   See: get_traj_raw_data2 for all scan data needed to be generated
    #   Everything else is mostlikly from the ini file 
    

    #Get ini file for system definition
    prefix = "C:/Users/elias/Desktop/Shadowfax/Data"
    
    pathnames = [
                 '/20200909/Simulation_2/',             #0
                 ]
    
    ProjectToRun=0
    n=np.array([1,1,1,1,1,1])
    for Project_Folder in [ProjectToRun]:
        #Create a ScanProject
        data_path_handler= DataPathHandler(prefix,pathnames)
        data_path_handler.get_data_paths() # pathes are stored in, data_path_handler.Files

        DataHandler=_DH() #Class object that can process data 
        ScanProject = DataObject(data_path_handler, Project_Folder,loadSaveData=0) #Class object that stores all data for a given scan

        #Start a Simulator        
        Sim=_Sim(ScanProject)

        S,xx,yy,zz,XP,YP,XE,YE,XO,YO,ZI,MemIndexTracking=Sim.get_SMatrix(ScanProject)
        P=_PSF.get_ProbFromSmatrix(S)

        Hx,Hy =_MI.SobelFeldman2DKernal()
        SqCRBx=Get_CRB_2D(P,xx,Hx,n)
        #qCRBy=Get_CRB(P,yy,Hy,n)

        SqCRB=SqCRBx

        for i in range(SqCRB.shape[2]):
            fig = plt.figure(constrained_layout=True)
            ax0=fig.add_subplot()
            cs0=ax0.contourf(SqCRB[:,:,i],levels=np.linspace(0,200,50) ) 
            fig.colorbar(cs0,ax=ax0)
        
            save=1
            if save:
                file="T" + "_pos_" + str(i) + '.png'
                path="C:/Users/elias/Desktop/Shadowfax/Data/20200909/Simulation_2/"
                fig.savefig(path + file)
                plt.close()
            else:
                plt.show()

def Get_CRB_2D(P,xx,Hx,n):
    PHx=np.zeros(P.shape)
    PHxx=np.zeros(P.shape)
    for j in range(P.shape[2]):
        Dxx=_MI.conv_3D(xx[:,:,j]*1e-6, Hx) #[m]
        for i in range(P.shape[3]):
            PHx[:,:,j,i]=_MI.conv_3D(P[:,:,j,i], Hx)/Dxx
            PHxx[:,:,j,i]=_MI.conv_3D(PHx[:,:,j,i], Hx)/Dxx
        
    CRBx=np.zeros(P.shape[:-1])
    for i in range(P.shape[3]):
        CRBx=CRBx + n[i]*(P[:,:,:,i]**-2)*(PHx[:,:,:,i]**2-P[:,:,:,i]*PHxx[:,:,:,i])

    CRBx=1/CRBx #[m^2]
    #Put negative numbers to 0, we interpret negative number as convex curvature
    CRBx[np.where(CRBx<0)]=np.nan
    SqCRBx=np.sqrt(CRBx)*1e9 #[nm]
    return SqCRBx 

def Get_CRB(P,xx,Hx,n):
    PHx=np.zeros(P.shape)
    PHxx=np.zeros(P.shape)
    Dxx=_MI.conv_3D(xx*1e-6, Hx) #[m]
    for i in range(P.shape[3]):
        PHx[:,:,:,i]=_MI.conv_3D(P[:,:,:,i], Hx)/Dxx
        PHxx[:,:,:,i]=_MI.conv_3D(PHx[:,:,:,i], Hx)/Dxx
        
    CRBx=np.zeros(P.shape[:-1])
    for i in range(P.shape[3]):
        CRBx=CRBx + n[i]*(P[:,:,:,i]**-2)*(PHx[:,:,:,i]**2-P[:,:,:,i]*PHxx[:,:,:,i])

    CRBx=1/CRBx #[m^2]
    #Put negative numbers to 0, we interpret negative number as convex curvature
    CRBx[np.where(CRBx<0)]=np.nan
    SqCRBx=np.sqrt(CRBx)*1e9 #[nm]
    return SqCRBx 

def main4():
    #Doughnut calculations
    x=np.linspace(-6,6,1000)
    a=[0.5,-0.5,0]
    s=1

    f=np.zeros((len(a),len(x)))
    F=np.zeros((len(a),len(x)))
    for i in range(len(a)):
        f[i,:]=((x-a[i])**2 / (2*s**2)) * np.exp(-((x-a[i])**2 / (2*s**2)))
        F[i,:]=np.exp(-((x-a[i])**2 / (2*s**2)))
    
    g=np.zeros((len(a),len(x)))
    G=np.zeros((len(a),len(x)))
    for i in range(len(a)): 
        g[i,:]=f[i,:] / np.sum(f, axis=0)
        G[i,:]=F[i,:] / np.sum(F, axis=0)
    
    
    #for i in range(len(g[:,0])):
    #    plt.plot(x,g[i,:])
    plt.plot(x,f[0,:],'b')
    plt.plot(x,f[1,:],'g')
    plt.plot(x,f[2,:],'r')

    plt.grid()
    plt.show()
    print("Done") 

def main5():
    N=30 #total amount of photons
    x=np.array(range(N-1))+1 #possible none zero photon values in one detector 
    alpha=175 #[nm] distance/2 between beams
    sigma=169 #[nm]  sigma of PSF for xy it is about 135-169nm
    y=(alpha**2/sigma)*np.log((N-x)/x)/2 #Distance out from center for a given photon count, tophat cut

    #plt.plot(x,y,'-*')
    #plt.grid()
    #plt.show()

    L=np.array(range(300))+10 #tophat cuting radius 
    N=np.exp(2*L*alpha/sigma**2)+1

    plt.plot(L,N,'-')
    plt.xlabel('Interval half length [nm] of none inf points')
    plt.ylabel('Total photon counts N')
    plt.grid()
    plt.show()

def main7():
    N=15 #total amount of photons
    alpha=175 #[nm] distance/2 between beams
    sigma=169 #[nm]  sigma of PSF for xy it is about 135-169nm
    
    p1=(np.array(range(9))+1)/10
    p2=1-p1
    
    Svalues=(np.array(range(100))+0.5)/10
    S=Svalues
    #Svalues[-1]=10000
    LegnedText=tuple()
    
    for i in range(9):
        y=np.sqrt( ((sigma**2 / (2*alpha))**2)*( 2*S**2 -1 + (S+0.5)/((S+1)*p1[i]*p2[i]) )/( 2*N*(S**2)*p1[i]*p2[i] ) )
        LegnedText= LegnedText + ("p1=" + str(p1[i]),)
        plt.plot(S,y)

    plt.xlim((0,10))
    plt.ylim((40,100))
    plt.xlabel('S')
    plt.ylabel('sqrt(SRB)')
    plt.title('CRB, ' + 'alpha=' + str(alpha) + 'nm, sigma=' + str(sigma) + 'nm' + ', N=' + str(N))
    plt.legend(LegnedText)
    plt.grid()
    plt.show()

    #L=np.array(range(300))+10 #tophat cuting radius 
    #N=np.exp(2*L*alpha/sigma**2)+1

    #plt.plot(L,N,'-')
    #plt.xlabel('Interval half length [nm] of none inf points')
    #plt.ylabel('Total photon counts N')
    #plt.grid()
    #plt.show()


def main6():
    import pandas as pd
    df = pd.read_csv (r'C:/Users/elias/Desktop/Shadowfax/Data/20201002/P_beam_configuration/Plot_Values.csv')
    a=df['Y0'].to_numpy()
    b=df['Y1'].to_numpy()
    b[-1]=b[-1][:-1]
    b=b.astype(np.float)

    #plt.plot(a); plt.plot(b); plt.show()
    x=np.linspace(0,1,10)
    for i in range(30):
        aa=a.copy()[i+1:]
        bb=b.copy()[:-(i+1)]
        #plt.plot(aa); plt.plot(bb); plt.show()
        fig = plt.figure()
        ax=fig.add_subplot()
        for xx in x:
            y=(aa**(xx) * bb**(1-xx))**1
            T=np.zeros(len(y))
            T[len(y)//2-10:len(y)//2+10]=1
            ax.plot(y)
            ax.plot(np.argmax(y*T),y[np.argmax(y*T)],'r*')
            
        if 1:
            file="T_"  + "_pos_" + str(i) + '.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20201002/P_beam_configuration/Debug/"
            fig.savefig(path + file)
            plt.close()            
        else:
            plt.show()

    print("Done!")

def main8():
    """
    Test of MSD for a Brownian motion
    """
    do_save_plot=1

    #Simulation track
    steps=1000
    substeps=1       #Simulate blur this will give R=1/6.2
    #T=1               #[s]
    dt=0.21e-3        #[s]
    sigma_e= 40e-3    #[um]
    sigma_e_z=sigma_e #[um]
    D_theory1=0.1     #[um^2/s]
    steps1=80
    D_theory2=2   #[um^2/s]
    steps2=20


    # Analysis 
    wndw=5
    wndwS=1 #if 1 it is a moving average, if equal to wndw it is a fix window average
    #############################################################################
    # Create 3D Brownian motion 
    k=np.arange(steps)
    DTrue=np.array([])
    dxdydz=np.array([[0,0,0]])
    for i in range(np.ceil(steps/(steps1+steps2)).astype('int')):
        dxdydz1 = np.random.normal(0, np.sqrt(2*D_theory1*(dt/substeps)), (int(steps1*substeps), 3))
        dxdydz=np.concatenate((dxdydz,dxdydz1))
        dxdydz2 = np.random.normal(0, np.sqrt(2*D_theory2*(dt/substeps)), (int(steps2*substeps), 3))
        dxdydz=np.concatenate((dxdydz,dxdydz2))
        DTrue=np.concatenate((DTrue,np.ones(steps1)*D_theory1))
        DTrue=np.concatenate((DTrue,np.ones(steps2)*D_theory2))

            
    trajT = np.cumsum(dxdydz[:-1,:], axis=0)
    traj=np.zeros((steps,3))
    for i in range(3):
        if substeps>1:
            traj[:,i]= np.convolve(np.ones(substeps)/substeps,trajT[:,i])[substeps-1:-substeps+1:substeps]
        else:
            traj[:,i]=trajT[:,i]
    

    X=traj[:,0] + np.random.normal(0, sigma_e, steps)      #[um]
    Y=traj[:,1] + np.random.normal(0, sigma_e, steps)      #[um]
    Z=traj[:,2] + np.random.normal(0, sigma_e_z, steps)     #[um]
    t_track=k*dt 

    txyzn_Map=np.vstack((t_track,X,Y,Z,k))

    TrajDictionary={}
    TrajToGet=0
    TrajDictionary[TrajToGet]=txyzn_Map
    ################################################################################################
    ### Estimate D and Sigma
    ################################################################################################
    
    #_PhLib.get_All_traj_CVE(TrajDictionary)
   
    #CVE estimation of D and sigma
    for index in range(12):
        if 0:
            if 0: #change n keeping j fixed, for an ofjset j move along the off diagonals 
                j=19
                js=np.ones(j)*j
                Flags=np.ones(j)*2
                Flags[0]=0
                ns=np.arange(j)
                ns[0]=1
    
                js=(np.append(1,js)).astype('int')
                ns=(np.append(1,ns)).astype('int')
                Flags=(np.append(0,Flags)).astype('int')
            else: #change j keeping n fixed, for a given offdiagonal n do several offsets 
                j=19
                n=1
                ns=(np.ones(j)*n).astype('int')
                Flags=(np.ones(j)*2).astype('int')
                js=(np.arange(j)+2).astype('int') #if Flag=0 j>0; Flag=1/2 j>1
               
            #CVE estimation of D and sigma
            result_txyz=_PhLib.get_CVE_MSD_traj(TrajDictionary,wndw=10,R=1/6.2,j=js[index],n=ns[index],Flag=Flags[index])
            t=result_txyz[str(TrajToGet),'D'][:,0]
            D=np.transpose(result_txyz[str(TrajToGet),'D'][:,1:])
            S2=np.transpose(result_txyz[str(TrajToGet),'Sigma2'][:,1:])
            #VarD=np.transpose(result_txyz[str(TrajToGet),'VarD'][:,1:])
            Name_prefix='CVE'
            Name_Mid='_j'+ str(js[index]) + '_n' + str(ns[index]) + '_F' + str(Flags[index])
        else: 
            #MSD estimation of D and sigma 
            PointsToUse=[2,3,4,5,6,7,8,9,10,11,12,13]
            MSDStart=[1,1,1,1,1,1,1,1,1,1,1,1]
            window=10
            MSDSteps=window-MSDStart[index]
            result_txyz =_PhLib.get_MSD_traj2(TrajDictionary,window=window,MSDStart=MSDStart[index],MSDSteps=MSDSteps,PointsToUse=PointsToUse[index],R=1/6.2,Flag=0)
            t=result_txyz[str(TrajToGet),'TDS2'][0]              #[s]
            D=result_txyz[str(TrajToGet),'TDS2'][1]               #[um^2/s]
            S2= result_txyz[str(TrajToGet),'TDS2'][2]             #[um^2]
            Name_prefix='MSD'
            Name_Mid= '_n' + str(PointsToUse[index]) + '_MS' + str(MSDStart[index])

            #Create runing mean 
        MD=np.mean(D,axis=0)
        MD = np.convolve(np.ones(wndw)/wndw,MD)
        MD=MD[wndw-1:-wndw+1:wndwS]

        MS2 = np.mean(S2,axis=0)
        MS2 = np.convolve(np.ones(wndw)/wndw,MS2)
        MS2 = MS2[wndw-1:-wndw+1:wndwS]

        Mt = np.convolve(np.ones(wndw)/wndw,t)
        Mt=Mt[wndw-1:-wndw+1:wndwS]

        DTrueTrunc=[]
        for indextime in range(len(t)):
            DTrueTrunc=np.concatenate((DTrueTrunc,[DTrue[np.argmin((t_track-t[indextime])**2)]]))
            
        DTrueTrunc1_Pointer=np.where(DTrueTrunc==D_theory1)
        DTrueTrunc2_Pointer=np.where(DTrueTrunc==D_theory2)
        
        ###############################################################
        # Figure construction CVE
        fig = plt.figure(constrained_layout=True)
        fig.set_size_inches(2*6, 2*5, forward=True)
        gs = GridSpec(3,4, figure=fig)
        ax0=fig.add_subplot(gs[0, 0:4]) #Trajectory 
        ax1=fig.add_subplot(gs[1, 0:3]) #Diffusion
        ax2=fig.add_subplot(gs[2, 0:3]) #Localization error 
        ax3=fig.add_subplot(gs[1, 3]) # Diffusion histogram 
        ax4=fig.add_subplot(gs[2, 3]) #Localization error  histogram

        ax0.set_title(Name_prefix + ' method for D and sigma')
        for i in range(np.floor(steps/(steps1+steps2)).astype('int')):
            if i==0:
                ax0.axvspan(txyzn_Map[0,i*(steps1+steps2)], txyzn_Map[0,i*(steps1+steps2)+steps1], alpha=0.5, color='white', label='D:'+str(D_theory1)+ ' t:' + str(steps1*dt))
                ax0.axvspan(txyzn_Map[0,i*(steps1+steps2)+steps1], txyzn_Map[0,(i+1)*(steps1+steps2)-1], alpha=0.2, color='gray', label='D:'+str(D_theory2)+ ' t:' + str(steps2*dt))
            else:
                ax0.axvspan(txyzn_Map[0,i*(steps1+steps2)], txyzn_Map[0,i*(steps1+steps2)+steps1], alpha=0.5, color='white')
                ax0.axvspan(txyzn_Map[0,i*(steps1+steps2)+steps1], txyzn_Map[0,(i+1)*(steps1+steps2)-1], alpha=0.2, color='gray')
        ax0.plot(txyzn_Map[0,:],txyzn_Map[1,:],'r'); ax0.plot(txyzn_Map[0,:],txyzn_Map[2,:],'g'); ax0.plot(txyzn_Map[0,:],txyzn_Map[3,:],'b')
        ax0.set_ylabel('um');ax0.grid();ax0.legend()

            
        # Diffusion constant estimation 
        #ax1.plot(t,D[0,:],'r'); ax1.plot(t,D[1,:],'g'); ax1.plot(t,D[2,:],'b')
        for i in range(np.floor(steps/(steps1+steps2)).astype('int')):
            #ax1.axvspan(txyzn_Map[0,i*(steps1+steps2)], txyzn_Map[0,i*(steps1+steps2)+steps1], alpha=0.5, color='white')
            ax1.axvspan(txyzn_Map[0,i*(steps1+steps2)+steps1], txyzn_Map[0,(i+1)*(steps1+steps2)-1], alpha=0.2, color='gray')
        ax1.plot(t,np.mean(D,axis=0),'k')
        ax1.plot(Mt,MD,'m') 
        ax1.plot(t_track,DTrue,'r') 
        #ax1.plot(Mt,np.ones(len(Mt))*D_theory1,'r') 
        #ax1.plot(Mt,np.ones(len(Mt))*D_theory2,'r')
        ax1.set_ylabel('um^2/s');ax1.grid()

        #Localization estimation 
        #ax2.plot(t,S2[0,:],'r'); ax2.plot(t,S2[1,:],'g'); ax2.plot(t,S2[2,:],'b')
        for i in range(np.floor(steps/(steps1+steps2)).astype('int')):
            #ax1.axvspan(txyzn_Map[0,i*(steps1+steps2)], txyzn_Map[0,i*(steps1+steps2)+steps1], alpha=0.5, color='white')
            ax2.axvspan(txyzn_Map[0,i*(steps1+steps2)+steps1], txyzn_Map[0,(i+1)*(steps1+steps2)-1], alpha=0.2, color='gray')        
        ax2.plot(t,np.mean(S2,axis=0)*1e6,'k')
        ax2.plot(Mt,MS2*1e6,'m')
        ax2.plot(Mt,(np.ones(len(Mt))*sigma_e**2)*1e6,'r',label='sigma: ' + str(sigma_e*1e3) + 'nm')
        ax2.plot(Mt,(np.ones(len(Mt))*(sigma_e_z)**2)*1e6,'--r')
        ax2.set_ylabel('nm^2');ax2.grid()
        ax2.set_xlabel('s')
        ax2.legend()
        
        # Histograms
        ax3.hist(np.mean(D,axis=0)-DTrueTrunc,bins=100,facecolor='b',label='M:'+ str(np.round(np.mean(np.mean(D,axis=0)-DTrueTrunc),decimals=2)) +  ' STD: '+ str(np.round(np.std(np.mean(D,axis=0)-DTrueTrunc),decimals=2)))
        #ax3.hist(np.mean(D,axis=0)[DTrueTrunc1_Pointer]-DTrueTrunc[DTrueTrunc1_Pointer],bins=100,facecolor='g', alpha=0.5)
        #ax3.hist(np.mean(D,axis=0)[DTrueTrunc2_Pointer]-DTrueTrunc[DTrueTrunc2_Pointer],bins=100,facecolor='r', alpha=0.5)
        #ax3.axvline(D_theory1, color='r',linestyle='--')
        #ax3.axvline(D_theory2, color='r',linestyle='--')
        ax3.legend()
        ax4.hist((np.mean(S2,axis=0)-sigma_e**2)*1e6,bins=100,label='M:'+ str(np.round(np.mean((np.mean(S2,axis=0)-sigma_e**2)*1e6),decimals=0).astype('int')) + ' STD: '+ str(np.round(np.std((np.mean(S2,axis=0)-sigma_e**2)*1e6),decimals=0).astype('int')))
        #ax4.axvline(sigma_e**2, color='r',linestyle='--')
        #ax4.axvline(sigma_e_z**2, color='r',linestyle='--')
        ax4.legend();ax4.set_xlabel('nm^2')

        if do_save_plot:
            file= Name_prefix + Name_Mid + '.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/Debug/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

        print('Done!')

def main8a():
    """
    Test of MSD and CVE for a simulated Brownian motion
    """
    do_save_plot=0

    #Simulation track
    steps=1000
    substeps=1       #Simulate blur this will give R=1/6.2
    #T=1              #[s]
    dt=0.84e-3        #[s]
    sigma_e= 40e-3    #[um]
    sigma_e_z=sigma_e #[um]
    D_theory1=0.1     #[um^2/s]
    steps1=80
    D_theory2=5       #[um^2/s]
    steps2=20
    DBias=0.6         #For analysis 

    # Analysis 
    wndw=5
    wndwS=1 #if 1 it is a moving average, if equal to wndw it is a fix window average
    #############################################################################
    # Create 3D Brownian motion 
    k=np.arange(steps)
    DTrue=np.array([])
    dxdydz=np.array([[0,0,0]])
    for i in range(np.ceil(steps/(steps1+steps2)).astype('int')):
        dxdydz1 = np.random.normal(0, np.sqrt(2*D_theory1*(dt/substeps)), (int(steps1*substeps), 3))
        dxdydz=np.concatenate((dxdydz,dxdydz1))
        dxdydz2 = np.random.normal(0, np.sqrt(2*D_theory2*(dt/substeps)), (int(steps2*substeps), 3))
        dxdydz=np.concatenate((dxdydz,dxdydz2))
        DTrue=np.concatenate((DTrue,np.ones(steps1)*D_theory1))
        DTrue=np.concatenate((DTrue,np.ones(steps2)*D_theory2))

            
    trajT = np.cumsum(dxdydz[:-1,:], axis=0)
    traj=np.zeros((steps,3))
    for i in range(3):
        if substeps>1:
            traj[:,i]= np.convolve(np.ones(substeps)/substeps,trajT[:,i])[substeps-1:-substeps+1:substeps]
        else:
            traj[:,i]=trajT[:,i]
    

    X=traj[:,0] + np.random.normal(0, sigma_e, steps)      #[um]
    Y=traj[:,1] + np.random.normal(0, sigma_e, steps)      #[um]
    Z=traj[:,2] + np.random.normal(0, sigma_e_z, steps)     #[um]
    t_track=k*dt 

    txyzn_Map=np.vstack((t_track,X,Y,Z,k))

    TrajDictionary={}
    TrajToGet=0
    TrajDictionary[TrajToGet]=txyzn_Map
    ################################################################################################
    ### Estimate D and Sigma
    ################################################################################################

    #CVE estimation of D and sigma
    j=15;n=1;Flag=2
    result_txyz=_PhLib.get_CVE_MSD_traj(TrajDictionary,wndw=10,R=1/6.2,j=j,n=n,Flag=Flag)
    t=result_txyz[str(TrajToGet),'D'][:,0]
    D=np.transpose(result_txyz[str(TrajToGet),'D'][:,1:])
    S2=np.transpose(result_txyz[str(TrajToGet),'Sigma2'][:,1:])
    #VarD=np.transpose(result_txyz[str(TrajToGet),'VarD'][:,1:])
    Name_prefix='CVE'
    Name_Mid='_j'+ str(j) + '_n' + str(n) + '_F' + str(Flag)
 
        #Create runing mean 
    MD=np.mean(D,axis=0)
    MD = np.convolve(np.ones(wndw)/wndw,MD)
    MD=MD[wndw-1:-wndw+1:wndwS]

    MS2 = np.mean(S2,axis=0)
    MS2 = np.convolve(np.ones(wndw)/wndw,MS2)
    MS2 = MS2[wndw-1:-wndw+1:wndwS]

    Mt = np.convolve(np.ones(wndw)/wndw,t)
    Mt=Mt[wndw-1:-wndw+1:wndwS]

    DTrueTrunc=[]
    for indextime in range(len(t)):
        DTrueTrunc=np.concatenate((DTrueTrunc,[DTrue[np.argmin((t_track-t[indextime])**2)]]))
            
    DTrueTrunc1_Pointer=np.where(DTrueTrunc==D_theory1)
    DTrueTrunc2_Pointer=np.where(DTrueTrunc==D_theory2)
    
    #Fitt Gamma function 
    fit_alpha, fit_loc, fit_scale=stats.gamma.fit(np.mean(D+DBias,axis=0))
    invfit_alpha, invfit_loc, invfit_scale=stats.invgamma.fit(np.mean(D+DBias,axis=0))
    invfit_alpha2, invfit_loc2, invfit_scale2=stats.invgamma.fit(np.mean(D,axis=0))

    DFittParam=np.linspace(0,30,num=1000)
    PDF_Gamma=stats.gamma.pdf(DFittParam, a=fit_alpha,loc=fit_loc, scale=fit_scale)
    PDF_invGamma=stats.invgamma.pdf(DFittParam, a=invfit_alpha,loc=invfit_loc, scale=invfit_scale)
    PDF_invGamma2=stats.invgamma.pdf(DFittParam, a=invfit_alpha2,loc=invfit_loc2, scale=invfit_scale2)

    DFittParam=DFittParam-DBias
    fit_beta=1/fit_scale
    invfit_beta=invfit_scale 
    invfit_beta2=invfit_scale2 
    GammaMean=(fit_alpha/fit_beta)+fit_loc-DBias
    GammaMode=((fit_alpha-1)/fit_beta)+fit_loc-DBias
    invGammaMean=(invfit_beta/(invfit_alpha-1))+invfit_loc-DBias
    invGammaMode=(invfit_beta/(invfit_alpha+1))+invfit_loc-DBias
    
    invGammaMean2=(invfit_beta2/(invfit_alpha2-1))+invfit_loc2
    invGammaMode2=(invfit_beta2/(invfit_alpha2+1))+invfit_loc2

    ###############################################################
    # Figure construction CVE
    fig = plt.figure(constrained_layout=True)
    fig.set_size_inches(2*6, 2*5, forward=True)
    gs = GridSpec(3,4, figure=fig)
    ax0=fig.add_subplot(gs[0, 0:4]) #Trajectory 
    ax1=fig.add_subplot(gs[1, 0:3]) #Diffusion
    ax2=fig.add_subplot(gs[2, 0:3]) #Localization error 
    ax3=fig.add_subplot(gs[1, 3]) # Diffusion histogram 
    ax4=fig.add_subplot(gs[2, 3]) #Localization error  histogram

    ax0.set_title(Name_prefix + ' method for D and sigma')
    for i in range(np.floor(steps/(steps1+steps2)).astype('int')):
        if i==0:
            ax0.axvspan(txyzn_Map[0,i*(steps1+steps2)], txyzn_Map[0,i*(steps1+steps2)+steps1], alpha=0.5, color='white', label='D:'+str(D_theory1)+ ' t:' + str(steps1*dt))
            ax0.axvspan(txyzn_Map[0,i*(steps1+steps2)+steps1], txyzn_Map[0,(i+1)*(steps1+steps2)-1], alpha=0.2, color='gray', label='D:'+str(D_theory2)+ ' t:' + str(steps2*dt))
        else:
            ax0.axvspan(txyzn_Map[0,i*(steps1+steps2)], txyzn_Map[0,i*(steps1+steps2)+steps1], alpha=0.5, color='white')
            ax0.axvspan(txyzn_Map[0,i*(steps1+steps2)+steps1], txyzn_Map[0,(i+1)*(steps1+steps2)-1], alpha=0.2, color='gray')
    ax0.plot(txyzn_Map[0,:],txyzn_Map[1,:],'r'); ax0.plot(txyzn_Map[0,:],txyzn_Map[2,:],'g'); ax0.plot(txyzn_Map[0,:],txyzn_Map[3,:],'b')
    ax0.set_ylabel('um');ax0.grid();ax0.legend()

            
    # Diffusion constant estimation 
    #ax1.plot(t,D[0,:],'r'); ax1.plot(t,D[1,:],'g'); ax1.plot(t,D[2,:],'b')
    for i in range(np.floor(steps/(steps1+steps2)).astype('int')):
        #ax1.axvspan(txyzn_Map[0,i*(steps1+steps2)], txyzn_Map[0,i*(steps1+steps2)+steps1], alpha=0.5, color='white')
        ax1.axvspan(txyzn_Map[0,i*(steps1+steps2)+steps1], txyzn_Map[0,(i+1)*(steps1+steps2)-1], alpha=0.2, color='gray')
    ax1.plot(t,np.mean(D,axis=0),'k')
    ax1.plot(Mt,MD,'m') 
    ax1.plot(t_track,DTrue,'r') 
    #ax1.plot(Mt,np.ones(len(Mt))*D_theory1,'r') 
    #ax1.plot(Mt,np.ones(len(Mt))*D_theory2,'r')
    ax1.set_ylabel('um^2/s');ax1.grid()

    #Localization estimation 
    #ax2.plot(t,S2[0,:],'r'); ax2.plot(t,S2[1,:],'g'); ax2.plot(t,S2[2,:],'b')
    for i in range(np.floor(steps/(steps1+steps2)).astype('int')):
        #ax1.axvspan(txyzn_Map[0,i*(steps1+steps2)], txyzn_Map[0,i*(steps1+steps2)+steps1], alpha=0.5, color='white')
        ax2.axvspan(txyzn_Map[0,i*(steps1+steps2)+steps1], txyzn_Map[0,(i+1)*(steps1+steps2)-1], alpha=0.2, color='gray')        
    ax2.plot(t,np.mean(S2,axis=0)*1e6,'k')
    ax2.plot(Mt,MS2*1e6,'m')
    ax2.plot(Mt,(np.ones(len(Mt))*sigma_e**2)*1e6,'r',label='sigma: ' + str(sigma_e*1e3) + 'nm')
    ax2.plot(Mt,(np.ones(len(Mt))*(sigma_e_z)**2)*1e6,'--r')
    ax2.set_ylabel('nm^2');ax2.grid()
    ax2.set_xlabel('s')
    ax2.legend()
        
    # Histograms D

    ax3.hist(np.mean(D,axis=0),bins=10,density=True,facecolor='b',label='M:'+ str(np.round(np.mean(np.mean(D,axis=0)),decimals=2)) +  ' STD: '+ str(np.round(np.std(np.mean(D,axis=0)),decimals=2)))
    ax3.plot(DFittParam+DBias,PDF_invGamma2,'-k',label='invGamma2')
    ax3.plot(DFittParam,PDF_invGamma,'-r',label='invGamma')
    ax3.axvline(invGammaMean2, color='g',linestyle='--',label='mean:' + str(np.round(invGammaMean2,decimals=2)))
    ax3.axvline(invGammaMode2, color='m',linestyle='--',label='mode:' + str(np.round(invGammaMode2,decimals=2)))
    ax3.axvline(invGammaMean, color='g',linestyle='-.',label='mean:' + str(np.round(invGammaMean,decimals=2)))
    ax3.axvline(invGammaMode, color='m',linestyle='-.',label='mode:' + str(np.round(invGammaMode,decimals=2)))
    ax3.legend()

    # Histograms S2
    ax4.hist((np.mean(S2,axis=0)-sigma_e**2)*1e6,bins=100,label='M:'+ str(np.round(np.mean((np.mean(S2,axis=0)-sigma_e**2)*1e6),decimals=0).astype('int')) + ' STD: '+ str(np.round(np.std((np.mean(S2,axis=0)-sigma_e**2)*1e6),decimals=0).astype('int')))
    ax4.legend();ax4.set_xlabel('nm^2')

    if do_save_plot:
        file= Name_prefix + Name_Mid + '.png'
        path="C:/Users/elias/Desktop/Shadowfax/Data/Debug/"
        fig.savefig(path + file)
        plt.close()
    else:
        plt.show()

    print('Done!')

def main8b():
    """
    Test of MSD and CVE for a simulated Brownian motion
    """
    do_save_plot=1

    ##### Generate HMM data 
    #Simulation track
    substeps=10                           #Simulate blur this will give R=1/6.2
    dt= 0.21e-3                           #[s]
    sigma_exyz= [30e-3,30e-3,40e-3]       #[um]
    D_true    =np.array([3,0.05])         #[um^2/s] mean of the D inverse gamma distribution 
    state_lifetime=np.array([5e-3,2e-3])  #[s]
    Mode=np.array([0.45*D_true[0],0.55*D_true[1]]) #Mode of the D inverse gamma distribution

    trans_mat = np.array([[1-(dt/state_lifetime[0]),dt/state_lifetime[0]],
                          [dt/state_lifetime[1],1-(dt/state_lifetime[1])]])
    n_sequences=50                  #Amount of trajectories to build 
    length_limits=[300,4000]        #trajectory length will be random between these valuse
    DBias=100                       #Analysis Bias to avoide negative values 


    model=_HMM.init_hmm_model(D_true,Mode,trans_mat)
    samples_all, StateGroundTruth= _HMM.get_sample_sequences(model, n_sequences=n_sequences, length_limits=length_limits)

    #############################################################################
    # Create 3D Brownian motion using StateGroundTruth
    traj_all=()
    for sequence in StateGroundTruth:
        var=np.sqrt(2*D_true[sequence.astype('int')]*(dt/substeps))
        var_substeps=np.repeat(np.expand_dims(var,axis=1),substeps,axis=1)
        var3D_substeps=np.repeat(np.expand_dims(var_substeps,axis=2),3,axis=2)
        dxdydz = np.random.normal(0, var3D_substeps)
        dxdydz=dxdydz.reshape((dxdydz.shape[0]*dxdydz.shape[1],dxdydz.shape[2]),order='C')
        dxdydz[0,:]=0
            
        trajT = np.cumsum(dxdydz, axis=0)
        traj=np.zeros((len(sequence),3))
        for i in range(3):
            if substeps>1:
                traj[:,i]= np.convolve(np.ones(substeps)/substeps,trajT[:,i])[substeps-1:-substeps+1:substeps]
            else:
                traj[:,i]=trajT[:,i]
        traj_all += (traj,)
    
    TrajDictionary={}
    for TrajToGet in range(len(traj_all)):
        traj=traj_all[TrajToGet]
        k=StateGroundTruth[TrajToGet]

        traj= traj +  np.random.normal(0, np.ones(traj.shape)*np.array([sigma_exyz])) #[um]
        t_track=dt*np.arange(traj.shape[0])
        txyzn_Map=np.vstack((t_track,traj.T,k))

        TrajDictionary[TrajToGet]=txyzn_Map
    

    
    ################################################################################################
    ### Estimate D and Sigma
    ###############################################################################################
    if 1: #CVE estimation of D and sigma
        j=2;n=1;window=5; Flag=2
        result_txyz=_PhLib.get_CVE_MSD_traj(TrajDictionary,wndw=window,R=1/6.2,j=j,n=n,Flag=Flag)
        Name_prefix='CVE_2stateHMM'
        Name_Mid='_j'+ str(j) + '_n' + str(n) + '_F' + str(Flag) + '_'

    else: #MSD estimation of D and sigma 
        PointsToUse=4;  MSDStart=1; window=5; Flag=0
        MSDSteps=window-MSDStart
        result_txyz_temp =_PhLib.get_MSD_traj2(TrajDictionary,window=window,MSDStart=MSDStart,MSDSteps=MSDSteps,PointsToUse=PointsToUse,R=1/6.2,Flag=Flag)

        result_txyz={}
        for TrajToGet in range(len(result_txyz_temp)):
            t=result_txyz_temp[str(TrajToGet),'TDS2'][0]   #[s]
            D=result_txyz_temp[str(TrajToGet),'TDS2'][1]   #[um^2/s]
            S2= result_txyz_temp[str(TrajToGet),'TDS2'][2] #[um^2]
            result_txyz[str(TrajToGet),'D']=np.append(np.expand_dims(t,axis=1).T,D,axis=0).T
            result_txyz[str(TrajToGet),'Sigma2']=np.append(np.expand_dims(t,axis=1).T,S2,axis=0).T           

        Name_prefix='MSD'
        Name_Mid= '_n' + str(PointsToUse) + '_MS' + str(MSDStart) +'_F' + str(Flag) + '_'
   
    #Find HMM 
    Dinv_all=()
    for i in range(int(len(result_txyz)/3)):
        Dinv=1/(np.mean(result_txyz[str(i),'D'][:,1:],axis=1)+DBias)
        Dinv_all+=(Dinv,)
    dt_est=np.mean(np.diff(result_txyz[str(0),'D'][:,0]))
    
    FoundModel=_HMM.train_HMM(X=Dinv_all, n_components=2)
    new_trans_mat, dist_params =_HMM.get_model_parm(FoundModel)   
    new_lifetime=[dt_est/new_trans_mat[0,1],dt_est/new_trans_mat[1,0]] #[s]
    print(trans_mat)
    print(new_trans_mat)

    D_estimated=()
    for state in dist_params:
        D_estimated+=(dist_params[state][1]/(dist_params[state][0]-1) -DBias,)
    predicted_state_sequence=_HMM.predict_sequence(model=FoundModel,observed_sequence=Dinv_all)
    
    # Generate the inverse-Gamma distributions to plot
    plotRange=[0,20]
    bins=200
    DFittParam=np.linspace(plotRange[0],plotRange[1],num=bins*10)
    invGamma={}
    for state in dist_params:
        param=dist_params[state]
        invGamma[state]=stats.invgamma.pdf(DFittParam+DBias, a=param[0],scale=param[1])


    ###############################################################
    ## Ploting
    for TrajToGet in range(10):#range(len(TrajDictionary)):
        txyzn_Map=TrajDictionary[TrajToGet]

        t=result_txyz[str(TrajToGet),'D'][:,0]
        D=np.transpose(result_txyz[str(TrajToGet),'D'][:,1:])
        S2=np.transpose(result_txyz[str(TrajToGet),'Sigma2'][:,1:])
 
        ts=()
        for tsearch in t:
            ts+=(np.argmin((txyzn_Map[0,:]-tsearch)**2),)
        
        ST  =(((D_true-np.mean(D_true))>0)*1.0)[txyzn_Map[4,:].astype('int')][np.array(ts)]
        SEst=(((np.array(D_estimated)-np.mean(np.array(D_estimated)))>0)*1.0)[predicted_state_sequence[TrajToGet]]
        StateTransError=ST-SEst
        StateTransErrorFailure=100*np.sum(np.abs(StateTransError))/len(StateTransError)

        ###############################################################
        # Figure construction CVE
        fig = plt.figure(constrained_layout=True)
        fig.set_size_inches(2*6, 2*5, forward=True)
        gs = GridSpec(3,4, figure=fig)
        ax0=fig.add_subplot(gs[0, 0:3]) #Trajectory 
        ax1=fig.add_subplot(gs[1, 0:3]) #Diffusion
        ax2=fig.add_subplot(gs[2, 0:3]) #Localization error 
        ax3=fig.add_subplot(gs[1, 3])   #Diffusion histogram 
        ax4=fig.add_subplot(gs[2, 3])   #Localization error  histogram
        ax5=fig.add_subplot(gs[0, 3])   #HMM error distribution 

        ax0.set_title(Name_prefix + ' method for D and sigma')
        colors=['white','gray']
        for i in range(len(txyzn_Map[0,:])-1):
            ax0.axvspan(txyzn_Map[0,i], txyzn_Map[0,i+1], alpha=0.5, color=colors[txyzn_Map[4,i].astype('int')],lw=0)
        ax0.plot(txyzn_Map[0,:],txyzn_Map[1,:],'r'); ax0.plot(txyzn_Map[0,:],txyzn_Map[2,:],'g'); ax0.plot(txyzn_Map[0,:],txyzn_Map[3,:],'b')
        ax0.set_ylabel('um');ax0.grid();#ax0.legend()    
            
        # Diffusion constant estimation 
        for i in range(len(txyzn_Map[0,:])-1):
            ax1.axvspan(txyzn_Map[0,i], txyzn_Map[0,i+1], alpha=0.5, color=colors[txyzn_Map[4,i].astype('int')],lw=0)
        ax1.plot(t,np.mean(D,axis=0),'k')
        ax1.plot(txyzn_Map[0,:],D_true[txyzn_Map[4,:].astype('int')],'g',label='D-true:' + str(np.round(D_true,decimals=2)) + ' Ltime:' + str(np.round(state_lifetime*1e3,decimals=2)) + 'ms') 
        ax1.plot(t,np.array(D_estimated)[predicted_state_sequence[TrajToGet]],'r',label='D-est:'+str(np.round(np.array(D_estimated),decimals=2)) + ' Ltime:' + str(np.round(np.array(new_lifetime)*1e3,decimals=2)) + 'ms')
        ax1.set_ylabel('um^2/s');ax1.grid()
        ax1.legend()
        
        #Localization estimation 
        for i in range(len(txyzn_Map[0,:])-1):
            ax2.axvspan(txyzn_Map[0,i], txyzn_Map[0,i+1], alpha=0.5, color=colors[txyzn_Map[4,i].astype('int')],lw=0)
        ax2.plot(t,np.mean(S2,axis=0)*1e6,'k')
        ax2.plot(t,(np.ones(len(t))*np.mean(sigma_exyz)**2)*1e6,'r',label='sigma-true: ' + str(np.round(np.mean(sigma_exyz)*1e3,decimals=2)) + 'nm')
        ax2.set_ylabel('nm^2');ax2.grid()
        ax2.set_xlabel('s')
        ax2.legend()
        
        # Histograms D
        for state in invGamma:
            ax3.plot(DFittParam,invGamma[state],label=state)
            ax3.axvline(dist_params[state][1]/(dist_params[state][0]-1) -DBias, color='g',linestyle='--',label=state + ' mean:' + str(np.round(dist_params[state][1]/(dist_params[state][0]-1)-DBias,decimals=2)))
            ax3.axvline(dist_params[state][1]/(dist_params[state][0]+1) -DBias, color='r',linestyle='--',label=state + ' mode:' + str(np.round(dist_params[state][1]/(dist_params[state][0]+1)-DBias,decimals=2)))

        ax3.hist(np.mean(D,axis=0),bins=10,density=True,facecolor='b',label='M:'+ str(np.round(np.mean(np.mean(D,axis=0)),decimals=2)) +  ' STD: '+ str(np.round(np.std(np.mean(D,axis=0)),decimals=2)))
        ax3.set_ylim(0,1)
        ax3.legend()

        # Histograms S2
        ax4.hist(np.mean(S2,axis=0)*1e6,bins=100,label='sqrt(|M|):'+ str(np.round(np.sqrt(np.abs(np.mean(np.mean(S2,axis=0))))*1e3,decimals=0).astype('int')) + 'nm \n' + ' sqrt(STD): '+ str(np.round(np.sqrt(np.std(np.mean(S2,axis=0)))*1e3,decimals=0).astype('int')) + 'nm')
        ax4.legend();ax4.set_xlabel('nm^2')
        
        #Histogram State estimation
        ax5.hist(StateTransError,bins=6,label='StateTrue-StateEst \n' + 'Failures:' + str(np.round(StateTransErrorFailure,decimals=2)) + '%')
        ax5.legend()

        if do_save_plot:
            file= Name_prefix + Name_Mid + str(TrajToGet) +'.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/Debug/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

        print('Done!')

def main8c():
    """
    Test of MSD and CVE for a simulated Brownian motion
    """
    do_save_plot=0

    ##### Generate HMM data 
    #Simulation track
    substeps=10                           #Simulate blur this will give R=1/6.2
    dt= 0.21e-3                           #[s]
    sigma_exyz= [30e-3,30e-3,40e-3]       #[um]
    D_true    =np.array([3,1,0.01])           #[um^2/s] mean of the D inverse gamma distribution 
    state_lifetime=np.array([5e-3,2e-3,100e-3])  #[s]
    Mode=np.array([0.45*D_true[0],0.55*D_true[1],0.55*D_true[2]]) #Mode of the D inverse gamma distribution
        #HMM Model 
    aii=1-(dt/state_lifetime)  #Probability to stay in the position is given by the life time 
    a23=a32=0                  #Moving from Test state (state 2) to a Bound state (state 3) can not be done 
    a21=(1-aii[1])             #a21+a22+a23=1
    a31=(1-aii[2])             #a31+a32+a33=1
    a12=(1-aii[0])*0.90        #Moving from Free state (state 1) to a Test state (state 2) is more probabule  
    a13=(1-aii[0])*0.10        #then moving from a Free state (state 1) to a Bound state (state 3)
    
    trans_mat = np.array([[aii[0],a12,a13],
                          [a21,aii[1],a23],
                          [a31,a32,aii[2]]])
    n_sequences=50                  #Amount of trajectories to build 
    length_limits=[300,4000]        #trajectory length will be random between these valuse
    DBias=100                       #Analysis Bias to avoide negative values 


    model=_HMM.init_hmm_model(D_true,Mode,trans_mat)
    samples_all, StateGroundTruth= _HMM.get_sample_sequences(model, n_sequences=n_sequences, length_limits=length_limits)

    #############################################################################
    # Create 3D Brownian motion using StateGroundTruth
    traj_all=()
    for sequence in StateGroundTruth:
        var=np.sqrt(2*D_true[sequence.astype('int')]*(dt/substeps))
        var_substeps=np.repeat(np.expand_dims(var,axis=1),substeps,axis=1)
        var3D_substeps=np.repeat(np.expand_dims(var_substeps,axis=2),3,axis=2)
        dxdydz = np.random.normal(0, var3D_substeps)
        dxdydz=dxdydz.reshape((dxdydz.shape[0]*dxdydz.shape[1],dxdydz.shape[2]),order='C')
        dxdydz[0,:]=0
            
        trajT = np.cumsum(dxdydz, axis=0)
        traj=np.zeros((len(sequence),3))
        for i in range(3):
            if substeps>1:
                traj[:,i]= np.convolve(np.ones(substeps)/substeps,trajT[:,i])[substeps-1:-substeps+1:substeps]
            else:
                traj[:,i]=trajT[:,i]
        traj_all += (traj,)
    
    TrajDictionary={}
    for TrajToGet in range(len(traj_all)):
        traj=traj_all[TrajToGet]
        k=StateGroundTruth[TrajToGet]

        traj= traj +  np.random.normal(0, np.ones(traj.shape)*np.array([sigma_exyz])) #[um]
        t_track=dt*np.arange(traj.shape[0])
        txyzn_Map=np.vstack((t_track,traj.T,k))

        TrajDictionary[TrajToGet]=txyzn_Map
    

    
    ################################################################################################
    ### Estimate D and Sigma
    ###############################################################################################
    if 1: #CVE estimation of D and sigma
        j=4;n=1;window=5; Flag=2
        result_txyz=_PhLib.get_CVE_MSD_traj(TrajDictionary,wndw=window,R=1/6.2,j=j,n=n,Flag=Flag)
        Name_prefix='CVE_2stateHMM'
        Name_Mid='_j'+ str(j) + '_n' + str(n) + '_F' + str(Flag) + '_'

    else: #MSD estimation of D and sigma 
        PointsToUse=4;  MSDStart=1; window=5; Flag=0
        MSDSteps=window-MSDStart
        result_txyz_temp =_PhLib.get_MSD_traj2(TrajDictionary,window=window,MSDStart=MSDStart,MSDSteps=MSDSteps,PointsToUse=PointsToUse,R=1/6.2,Flag=Flag)

        result_txyz={}
        for TrajToGet in range(len(result_txyz_temp)):
            t=result_txyz_temp[str(TrajToGet),'TDS2'][0]   #[s]
            D=result_txyz_temp[str(TrajToGet),'TDS2'][1]   #[um^2/s]
            S2= result_txyz_temp[str(TrajToGet),'TDS2'][2] #[um^2]
            result_txyz[str(TrajToGet),'D']=np.append(np.expand_dims(t,axis=1).T,D,axis=0).T
            result_txyz[str(TrajToGet),'Sigma2']=np.append(np.expand_dims(t,axis=1).T,S2,axis=0).T           

        Name_prefix='MSD'
        Name_Mid= '_n' + str(PointsToUse) + '_MS' + str(MSDStart) +'_F' + str(Flag) + '_'
   
    #Find HMM 
    HMM_n_components=3
    Dinv_all=()
    for i in range(int(len(result_txyz)/3)):
        Dinv=1/(np.mean(result_txyz[str(i),'D'][:,1:],axis=1)+DBias)
        Dinv_all+=(Dinv,)
    dt_est=np.mean(np.diff(result_txyz[str(0),'D'][:,0]))
    
    FoundModel=_HMM.train_HMM(X=Dinv_all, n_components=HMM_n_components)
    new_trans_mat, dist_params =_HMM.get_model_parm(FoundModel) 
    
    new_lifetime=()
    for i in range(new_trans_mat.shape[0]):
        new_lifetime+=(dt_est/(1-new_trans_mat[i,i]),) #[s]
    new_lifetime=np.array(new_lifetime)

    print(trans_mat)
    print(new_trans_mat)

    D_estimated=()
    for state in dist_params:
        D_estimated+=(dist_params[state][1]/(dist_params[state][0]-1) -DBias,)
    predicted_state_sequence=_HMM.predict_sequence(model=FoundModel,observed_sequence=Dinv_all)
    
    _HMM.plot_hist_sequence_with_fit(Dinv_all,dist_params,xoffset=DBias)

    # Generate the inverse-Gamma distributions to plot
    plotRange=[-5,20]
    bins=200
    DFittParam=np.linspace(plotRange[0],plotRange[1],num=bins*10)
    invGamma={}
    for state in dist_params:
        param=dist_params[state]
        invGamma[state]=stats.invgamma.pdf(DFittParam+DBias, a=param[0],scale=param[1])


    ###############################################################
    ## Ploting
    for TrajToGet in range(10):#range(len(TrajDictionary)):
        txyzn_Map=TrajDictionary[TrajToGet]

        t=result_txyz[str(TrajToGet),'D'][:,0]
        D=np.transpose(result_txyz[str(TrajToGet),'D'][:,1:])
        S2=np.transpose(result_txyz[str(TrajToGet),'Sigma2'][:,1:])
 
        ts=()
        for tsearch in t:
            ts+=(np.argmin((txyzn_Map[0,:]-tsearch)**2),)
        
        ST  =D_true[txyzn_Map[4,:].astype('int')][np.array(ts)]
        SEst=np.array(D_estimated)[predicted_state_sequence[TrajToGet]]
        StateTransError=ST-SEst       

        ###############################################################
        # Figure construction CVE
        fig = plt.figure(constrained_layout=True)
        fig.set_size_inches(2*6, 2*5, forward=True)
        gs = GridSpec(3,4, figure=fig)
        ax0=fig.add_subplot(gs[0, 0:3]) #Trajectory 
        ax1=fig.add_subplot(gs[1, 0:3]) #Diffusion
        ax2=fig.add_subplot(gs[2, 0:3]) #Localization error 
        ax3=fig.add_subplot(gs[1, 3])   #Diffusion histogram 
        ax4=fig.add_subplot(gs[2, 3])   #Localization error  histogram
        ax5=fig.add_subplot(gs[0, 3])   #HMM error distribution 

        ax0.set_title(Name_prefix + ' method for D and sigma')
        colors=['gray','bisque','white']

        StateSection=np.where((np.diff(txyzn_Map[4,:])!=0)*1)[0]
        StartSection=np.append(np.array([0]),StateSection+1)
        EndSection=np.append(StateSection+1,np.array(len(txyzn_Map[4,:])-1))
        #D_labelsTracker=len(D_true)

        for i in range(len(StartSection)):
            ax0.axvspan(txyzn_Map[0,StartSection[i]], txyzn_Map[0,EndSection[i]], alpha=0.5, color=colors[txyzn_Map[4,StartSection[i]].astype('int')],lw=0)#label=
            #print(str(D_true[txyzn_Map[4,StartSection[i]].astype('int')]))
        ax0.plot(txyzn_Map[0,:],txyzn_Map[1,:],'r'); ax0.plot(txyzn_Map[0,:],txyzn_Map[2,:],'g'); ax0.plot(txyzn_Map[0,:],txyzn_Map[3,:],'b')
        ax0.set_ylabel('um');ax0.grid();#ax0.legend()    
        
        # Diffusion constant estimation 
        for i in range(len(StartSection)):
            ax1.axvspan(txyzn_Map[0,StartSection[i]], txyzn_Map[0,EndSection[i]], alpha=0.5, color=colors[txyzn_Map[4,StartSection[i]].astype('int')],lw=0)
        ax1.plot(t,np.mean(D,axis=0),'k')
        ax1.plot(txyzn_Map[0,:],D_true[txyzn_Map[4,:].astype('int')],'g',label='D-true:' + str(np.round(D_true,decimals=2)) + ' Ltime:' + str(np.round(state_lifetime*1e3,decimals=2)) + 'ms') 
        ax1.plot(t,np.array(D_estimated)[predicted_state_sequence[TrajToGet]],'r',label='D-est:'+str(np.round(np.array(D_estimated),decimals=2)) + ' Ltime:' + str(np.round(np.array(new_lifetime)*1e3,decimals=2)) + 'ms')
        ax1.set_ylabel('um^2/s');ax1.grid()
        ax1.legend()
        
        #Localization estimation 
        for i in range(len(StartSection)):
            ax2.axvspan(txyzn_Map[0,StartSection[i]], txyzn_Map[0,EndSection[i]], alpha=0.5, color=colors[txyzn_Map[4,StartSection[i]].astype('int')],lw=0)
        ax2.plot(t,np.mean(S2,axis=0)*1e6,'k')
        ax2.plot(t,(np.ones(len(t))*np.mean(sigma_exyz)**2)*1e6,'r',label='sigma-true: ' + str(np.round(np.mean(sigma_exyz)*1e3,decimals=2)) + 'nm')
        ax2.set_ylabel('nm^2');ax2.grid()
        ax2.set_xlabel('s')
        ax2.legend()
        
        # Histograms D
        for state in invGamma:
            ax3.plot(DFittParam,invGamma[state],label=state)
            ax3.axvline(dist_params[state][1]/(dist_params[state][0]-1) -DBias, color='g',linestyle='--',label=state + ' mean:' + str(np.round(dist_params[state][1]/(dist_params[state][0]-1)-DBias,decimals=2)))
            ax3.axvline(dist_params[state][1]/(dist_params[state][0]+1) -DBias, color='r',linestyle='--',label=state + ' mode:' + str(np.round(dist_params[state][1]/(dist_params[state][0]+1)-DBias,decimals=2)))

        ax3.hist(np.mean(D,axis=0),bins=10,density=True,facecolor='b',label='M:'+ str(np.round(np.mean(np.mean(D,axis=0)),decimals=2)) +  ' STD: '+ str(np.round(np.std(np.mean(D,axis=0)),decimals=2)))
        ax3.set_ylim(0,1)
        ax3.legend()

        # Histograms S2
        ax4.hist(np.mean(S2,axis=0)*1e6,bins=100,label='sqrt(|M|):'+ str(np.round(np.sqrt(np.abs(np.mean(np.mean(S2,axis=0))))*1e3,decimals=0).astype('int')) + 'nm \n' + ' sqrt(STD): '+ str(np.round(np.sqrt(np.std(np.mean(S2,axis=0)))*1e3,decimals=0).astype('int')) + 'nm')
        ax4.legend();ax4.set_xlabel('nm^2')
        
        #Histogram State estimation
        ax5.hist(StateTransError,bins=20,label='StateTrue-StateEst')
        ax5.legend()

        if do_save_plot:
            file= Name_prefix + Name_Mid + str(TrajToGet) +'.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/Debug/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

        print('Done!')

def main9():
    """
    Simple test to see how many pixles that a diffution partical with diffusion constant D will move an average on a cammera image
    """
    D=np.linspace(0,20,100)  #[um^2/s]
    F_rate=5e-3              #[s]
    Pixel = 80e-3             #[um]

    PixDis=2*np.sqrt(D*F_rate)/Pixel
    plt.plot(D,PixDis)
    plt.grid()
    plt.show()

                 

if __name__ == '__main__':
    main8a()

    #main2()


    
   

    """
    # Spline interpolation migh also be something to test 
    # See: https://stackoverflow.com/questions/46040382/spline-interpolation-in-3d-in-python

    xs=ys=10
    zs=5
    xp=21
    yp=21
    zp=30

    x = np.linspace(0,20,xp)
    y = np.linspace(0,20,yp)
    z = np.linspace(0,29,zp)
    xx,yy,zz=np.meshgrid(x,y,z)
    V = np.zeros((yp,xp,zp))
    for i in range(yp):
        for j in range(xp):
            for k in range(zp):
                V[i,j,k] = 100*y[i] + 10*x[j] + z[k]
    
    xyzd=np.transpose(np.array([xx.flatten(),yy.flatten(),zz.flatten(),V.flatten()]))
    fn = sp.interpolate.Rbf(xyzd[:,0],xyzd[:,1],xyzd[:,2],xyzd[:,3],function='gaussian')

    xn = np.linspace(0,20,xp*xs)
    yn = np.linspace(0,20,yp*ys)
    zn = np.linspace(0,29,zp*zs)
    xxn,yyn,zzn=np.meshgrid(xn,yn,zn)
    xyz=np.transpose(np.array([xxn.flatten(),yyn.flatten(),zzn.flatten()]))
    Vn=fn(xyz[:100,0],xyz[:100,1],xyz[:100,2])
    
    Vnn=np.reshape(Vn, np.array(V.shape)*[xs,ys,zs])
    """