from PlotLibrary import TrajPlots as _TP

class PipelineOrganizer:

    def DataPipline(ScanProject,DataHandler,loadSaveData=1):
        loadSaveData=ScanProject.loadSaveData
        if loadSaveData:
            #ScanProject = DataHandler.UnPickleData(ScanProject)
            ScanProject1 = DataHandler.UnPickleData(ScanProject)
            ScanProject1.Files['AnalysisConfig']=ScanProject.Files['AnalysisConfig']
            ScanProject=ScanProject1
            DataHandler.get_ini_file(ScanProject) #Reload ini file if changes has ocurred 

            if ScanProject.SetupSpecifics['is_simulation']:
                DataHandler.CalcBasicPhotonStats(ScanProject) #Calculations are stored in, ScanObject.BasicStat

                DataHandler.get_raw_data_filter(ScanProject)  #Data stored in, ScanObject.filter_vector
                DataHandler.get_TrajObject() #Initiate trajectory function to the DataHandler
                DataHandler.get_Trajectories(ScanProject) # Calculations are stored in, TrajObject.Trajs, TrajObject.TrajInfo
                
                print('Amount of trajectoris found:' + str(ScanProject.Trajs.shape[1]) )

                DataHandler.PickleData(ScanProject,override=0)
        else: #Run the trajectory estimations
            DataHandler.getScanMatrix(ScanProject)   #Data stored in, ScanObject.ScanMatrix, ScanObject.ScanInfo
            DataHandler.CalcBasicPhotonStats(ScanProject) #Need to go through calculation and see what it is doing (Do not trust), Calculations are stored in, ScanObject.BasicStat
            
            DataHandler.get_raw_data_filter(ScanProject)  #Data stored in, ScanObject.filter_vector
            DataHandler.get_TrajObject() #Initiate trajectory function to the DataHandler
            DataHandler.get_Trajectories(ScanProject) # Calculations are stored in, TrajObject.Trajs, TrajObject.TrajInfo

            DataHandler.do_TrimTrajs(ScanProject, ScanProject.StartTrim, ScanProject.EndTrim, ScanProject.ForceMaxTrajLength)
            print('Amount of trajectoris found:' + str(ScanProject.Trajs.shape[1]) )
    
            if 0: #Plot photon counts for each traj
                #AmountOfTraj=len(ScanProject.PoissonProbXYZMap_NumPFS)
                AmountOfTraj=ScanProject.Trajs.shape[1]
                for TrajToGet in range(AmountOfTraj): 
                    _TP.plotPhotonCount(ScanProject,TrajToGet,do_save_plot=1)
                print('plotPhotonCount function Done!')
        
            # Trajectory estimations  
            if 1: # Gaussian
                DataHandler.get_Gaussian_traj_estimation(ScanProject) # Data saved under ScanProject.TrajPosEstimation
                print("Gaussian traje Done!")

            if 1: # Poisson Map with numerical PSF
                debug=0
                if debug:
                    for TrajToGet in range(2):
                        print("Procesing Traj:" + str(TrajToGet))
                        DataHandler.get_traj_Poisson_ProbMap_NumPFS(ScanProject,TrajToGet,verbose=1, do_onlinesave=1) # Calculations are stored in, ScanProject.TrajObject.PoissonProbXYMap
                else:
                    #TrajToGet=1
                    #DataHandler.get_traj_Poisson_ProbMap_NumPFS(ScanProject,TrajToGet,verbose=0, do_onlinesave=0) # Calculations are stored in, ScanProject.TrajObject.PoissonProbXYMap
                    DataHandler.get_All_traj_Poisson_ProbMap_NumPFS(ScanProject)                    
                    print("Poisson Map with numerical PSF traje Done!")
            
            if 1: #Get image to overlay tracks
                DataHandler.get_ovelayTrajOnCells(ScanProject,iterations_to_do=0,do_save_plot=1)
            
            if 1: #Pickel data                   
                DataHandler.PickleData(ScanProject,override=0)
                #DataHandler.savetoMat(ScanProject) #Change to correct saveTrajtomat

        if 1: #Trajectory filtering on, and transform the trajectories to the image ref-frame [um]
            ScanProject.TrajectorySelectionRules['MinTrajectoryTimeLength']=0.05 #[s]
            PhotonThreachhold=8
            wndw=10
            UseCellMask='IncludePartialInMask'
            MovieStepSize=0
            ScanProject.PoissonProbXYZMap_NumPFSFiltred=DataHandler.get_traj_toImagCoordinates(ScanProject, ScanProject.PoissonProbXYZMap_NumPFS)
            ScanProject.PoissonProbXYZMap_NumPFSCellMaskTrajFlag=DataHandler.get_traj_inCells(ScanProject, ScanProject.PoissonProbXYZMap_NumPFSFiltred,mask=UseCellMask)
            ScanProject.PoissonProbXYZMap_NumPFSFiltred=DataHandler.get_traj_filter(ScanProject, ScanProject.PoissonProbXYZMap_NumPFSFiltred, ScanProject.PoissonProbXYZMap_NumPFSCellMaskTrajFlag,PhotonThreachhold=PhotonThreachhold,wndw=wndw)
            _TP.plot_ovelayTrajOnCells2(ScanProject,ScanProject.PoissonProbXYZMap_NumPFSFiltred,CellMask=True,do_save_plot=1)

            DataHandler.get_MSD_traj(ScanProject, ScanProject.PoissonProbXYZMap_NumPFSFiltred)
            #for TrajToGet in range(len(ScanProject.PoissonProbXYZMap_NumPFSFiltred)):
            #    _TP.plot_Hist_Traj_MDS5(ScanProject,TrajToGet,ScanProject.PoissonProbXYZMap_NumPFSFiltred,do_save_plot=1)

            for TrajToGet in range(len(ScanProject.PoissonProbXYZMap_NumPFSFiltred)):
                _TP.plot_Hist_Traj_MDS6(ScanProject,TrajToGet,ScanProject.PoissonProbXYZMap_NumPFSFiltred,MovieStepSize=MovieStepSize,do_save_plot=1)
                

        if 0: # Calculate diffuision as a sliding window over the trajectory, ScanProject.txyzMSD_traj and ScanProject.txyzCVEMSD_traj
            PhotonThreachhold=8
            wndw=10
            ScanProject.PoissonProbXYZMap_NumPFSFiltred=DataHandler.get_traj_filter(ScanProject, ScanProject.PoissonProbXYZMap_NumPFS, Flag=True ,PhotonThreachhold=PhotonThreachhold,wndw=wndw)
            DataHandler.get_MSD_traj(ScanProject, ScanProject.PoissonProbXYZMap_NumPFSFiltred)
            if 1:
                for TrajToGet in range(len(ScanProject.PoissonProbXYZMap_NumPFSFiltred)):
                    if ScanProject.txyzCVEMSD_traj[str(TrajToGet),'D'].shape[0]!=0:
                        _TP.plot_Hist_Traj_MDS5(ScanProject,TrajToGet,ScanProject.PoissonProbXYZMap_NumPFSFiltred,do_save_plot=1)
            _TP.plot_Diffusion_Summery(ScanProject,ScanProject.PoissonProbXYZMap_NumPFSFiltred,do_save_plot=1)

        if 0: # Standard MSD calculation      
            #DataHandler.get_All_traj_MSD(ScanProject, ScanProject.PoissonProbXYZMap_NumPFS) #Data saved under ScanProject.txyzMSD_Poisson_ProbMap  
            DataHandler.get_All_traj_CVE(ScanProject, ScanProject.PoissonProbXYZMap_NumPFS)
            if 1: # Plot MSD and calculate diffusion and trajectory error      
                DataHandler.get_Diffusion(ScanProject) #Output plot

        if 0: # MSD calculation, Plot sum of MSD and calculate diffusion and trajectory error      
                DataHandler.get_Diffusion_SumAll(ScanProject) #Output plot

        if 0: #Ploting traj and standard MDS
            AmountOfTraj=len(ScanProject.PoissonProbXYZMap_NumPFS)
            for TrajToGet in range(AmountOfTraj): 
                _TP.plot_Hist_Traj(ScanProject,TrajToGet,do_save_plot=1)            

        if 0: # Calculate traj mean and std and plot it
            AmountOfTraj=len(ScanProject.PoissonProbXYZMap_NumPFS)
            for TrajToGet in range(AmountOfTraj): 
                #Plot is saved as name: T_1_M_STD_traj.png
                _TP.plot_Hist_Traj_Mean_STD(ScanProject,TrajToGet,wndw=100,do_save_plot=1)

        if 0: # Look at the displacment distribution
            DataHandler.get_MSD_Distribution(ScanProject, ScanProject.PoissonProbXYZMap_NumPFS)

        if 0: #Pickel data                   
            DataHandler.PickleData(ScanProject,override=0)
            #DataHandler.savetoMat(ScanProject) #Change to correct saveTrajtomat

        if 0: #Plot Piezo stage for each traj
            AmountOfTraj=len(ScanProject.PoissonProbXYZMap_NumPFS)
            for TrajToGet in range(AmountOfTraj): 
                _TP.plotPiezostages(ScanProject,TrajToGet,do_save_plot=0)

        if 0: #Plot photon counts for each traj
            #AmountOfTraj=len(ScanProject.PoissonProbXYZMap_NumPFS)
            AmountOfTraj=ScanProject.Trajs.shape[1]
            for TrajToGet in range(AmountOfTraj): 
                _TP.plotPhotonCount(ScanProject,TrajToGet,do_save_plot=0)
            print('plotPhotonCount function Done!')

        if 0: #Get image to overlay tracks
            DataHandler.get_ovelayTrajOnCells(ScanProject,do_save_plot=1)
            _TP.plot_ovelayTrajOnCells(ScanProject,do_save_plot=1)
            #AmountOfTraj=ScanProject.Trajs.shape[1]
            #for TrajToGet in range(AmountOfTraj): 

                
        return ScanProject


