import numpy as np
import matplotlib
#matplotlib.rcParams['text.usetex'] = True
import matplotlib.pyplot as plt
import matplotlib.gridspec as gridspec
from mpl_toolkits import mplot3d
from matplotlib import cm
from matplotlib.gridspec import GridSpec
import matplotlib.ticker as mticke


def main():
    fig = plt.figure()
    ax0=fig.add_subplot()
    for k in range(10):
        s=4
        n_mean=np.array([5.0])
        n=np.random.poisson(n_mean,s)

        nM=np.sum(n)/(n.shape[0]-1)
        nn=0.5+np.sqrt(0.25 + np.sum(np.power(n,2))/n.shape[0])
        print('intervall:' + str(nM-1.96*np.sqrt(nM/n.shape[0])) + ' to ' + str(nM+1.96*np.sqrt(nM/n.shape[0])) + ' with mean:' + str(nM) + ' or ' + str(nn))

        v=(np.array(range(0,1000))/100)
        x=n_mean+v-np.max(v)/2
        y2=np.zeros(x.shape[0])
        y4=np.zeros(x.shape[0])
        y6=np.zeros(x.shape[0])
        y8=np.zeros(x.shape[0])
        for i in range(len(x)):    
            y2[i]=np.sum(np.power(n-x[i],2))/n.shape[0]
            y4[i]=np.sum(np.power(n-x[i],4))/n.shape[0]
            y6[i]=np.sum(np.power(n-x[i],6))/n.shape[0]
            y8[i]=np.sum(np.power(n-x[i],8))/n.shape[0]
        print("Done!")
        
        
        
        argxmin=np.array([np.argmin(y2),np.argmin(y4),np.argmin(y6),np.argmin(y8)])
        ymin=np.array([ y2[argxmin[0]],y4[argxmin[1]],y6[argxmin[2]],y8[argxmin[3]] ])
        xmin=x[argxmin]
    
        ax0.plot(x,nM*x/x,'--g')
        ax0.plot(x,x,'-g')
        ax0.plot(x,y2,'-b')
        #ax0.plot(x,y4,'-b')
        #ax0.plot(x,y6,'-b')
        #ax0.plot(x,y8,'-b')
        ax0.plot(xmin[0],ymin[0],'-*r')
        ax0.plot(nn,nn,'*b')
        #ax0.set_yscale('log')

    plt.grid(True)
    plt.show()

def main2():
    fig = plt.figure()
    ax0=fig.add_subplot()

    for i in range(10):
        x=(np.array(range(1000))-500)/50
        k=2 #(i+1)/2
        d=0 #(i+1)/10
        f=1/(1+np.exp(d-k*x))
        f2=1/(1+np.exp(d+k*x))
        #ax0.plot(x,f,'-r')
        #ax0.plot(x,f2,'-g')
        p0=(f2**0.11)*(f**0.89)
        p1=(f2**0.3)*(f**0.7)
        p2=(f2**0.52)*(f**0.48)

        #pi=np.argmax(p)
        ax0.plot(x,p0,'-r')
        ax0.plot(x,p1,'-g')
        ax0.plot(x,p2,'-b')
        #ax0.plot(x[pi],p[pi],'*r')
        

    plt.grid(True)
    plt.show()

def main3():
    #Linear plains as likelihood function
    fig = plt.figure()
    ax0=fig.add_subplot()

    x=(np.array(range(1000))-500)/500
    a=np.array(range(10))/10

    f=np.zeros((x.shape[0],10))
    for i in range(len(a)):
        fp=(x+a[i])**2
        fm=(x-a[i])**2
        gp=fp/(fp+fm)
        gm=fm/(fp+fm)
        
        gpp=(a[i]**3 - a[i]*x**2)/((a[i]**2 + x**2)**2) 
        gpm=(-a[i]**3 + a[i]*x**2)/((a[i]**2 + x**2)**2)

        ax0.plot(x,gp,'-r')
        ax0.plot(x,gm,'-g')
    plt.grid(True)
    plt.show()

def main4():
    fig = plt.figure()
    ax = plt.axes(projection='3d')    

    x=0.5+np.array(range(1000))/100
    y=x.copy()
    xx,yy=np.meshgrid(x,y)

    z=np.abs(0.5*(xx-yy)*((xx+yy)/(xx*yy))**0.5)
    #sz=np.sqrt(xx*yy/((xx+yy)**3))
    sz=4*(xx*yy/((xx+yy)**2))
    #sz=np.sqrt((xx+yy)/(xx*yy))
    #z[np.isnan(z)]=0

    sz=np.sqrt( (((xx+yy)/(xx*yy))/4) + (2/(xx+yy)) + 4*(xx*yy/((xx+yy)**3)) )


    #b=np.abs(((np.log(yy)-np.log(xx))/2)+((yy-xx)/(xx+yy)))
    ax.plot_surface(xx, yy, sz, cmap=cm.coolwarm, linewidth=0, antialiased=False)
    #ax.contourf(xx, yy, b,50,linewidths=1)

    #plt.grid(True)
    plt.show()

def main5():

    for i in range(40):
        i=20
        i=i+1
        fig = plt.figure()
        ax0=fig.add_subplot()
    
        a=0.8*i
        b=0.2*i
        s=1000000

        #sigma=(0.822/2)*(540e-9 / 1.45) #Beam Gaussian sigma 
        #L=235e-9                        #Beam distance 
        k=1                             # Sigma**2/L 

        x=(k/2)*np.log(b/a)
        xbias=x-k*((a-b)/(a+b))

        crb_MLE2 =((k/2)**2)*(a+b)/(a*b)
        crb_LMLE2 =(k**2)*(4*a*b/((a+b)**3)) 
        
        na=np.random.poisson(a,s)
        nb=np.random.poisson(b,s)           
    
        Nnan=len(np.where((na+nb)==0)[0])
        Ninf= len(np.where(na*nb==0)[0]) -Nnan
    
        #MLE
        B1= x - (k/2)*np.log(nb/na)
        B1=B1[np.invert(np.isnan(B1))]
        B1=B1[np.invert(np.isinf(B1))]
        #B1=B1[np.invert(B1>0.4)]
    
        #LMLE
        B2= x - k*((na-nb)/(na+nb))
        B2=B2[np.invert(np.isnan(B2))]

        #LMLE-Bias OBS true Bias 
        B3= x - k*((na-nb)/(na+nb)) - xbias
        B3=B3[np.invert(np.isnan(B3))]

        #MLE truncated 
        B4= x - (k/2)*np.log(nb/na)
        B4=B4[np.invert(np.isnan(B4))]
        B4=B4[np.invert(np.isinf(B4))]
        B4=B4[np.invert(B4**2>0.4)]

        ax0.axvline(x=xbias**2, color='k')
        ax0.axvline(x=crb_MLE2, color='b')
        ax0.axvline(x=crb_LMLE2, color='r')
        ax0.hist(B1**2, 100, facecolor='m', alpha=0.5) #MLE
        ax0.hist(B2**2, 100, facecolor='g', alpha=0.5) #LMLE
        ax0.hist(B3**2, 100, facecolor='y', alpha=0.5) #LMLE-Bias
        ax0.hist(B4**2, 100, facecolor='m', alpha=0.5) #MLE-cropp
       
        #ax0.set_title('Nan: ' + str(Nnan) + ', Inf: ' + str(Ninf) + ', B1E: ' + str(np.round(np.mean(B1**2), decimals=3)) + ', B2E: ' + str(np.round(np.mean(B2**2), decimals=3)) + ', B3E: ' + str(np.round(np.mean(B3**2), decimals=3)) + ', crb MLE: ' + str(np.round(crb_MLE2, decimals=3)) + ', crb LMLE: ' + str(np.round(crb_LMLE2, decimals=3)))
        ax0.legend(('Bias','crb_MLE2','crb_LMLE2' ,'B1-MLE','B2-LMLE','B3-LMLE','B4-MLECopp'))

        plt.grid(True)
        plt.xlim(0, 3*k**2)

        textstr= ('Nan: ' + str(Nnan) + '\n' + 
                  'Inf: ' + str(Ninf)  + '\n' +
                  'a: '   + str(np.round(a, decimals=3))  + '  b: ' + str(np.round(b, decimals=3))  + '\n' +
                  'Bias2: ' + str(np.round(xbias**2, decimals=3))       + '\n' +
                  'MLE:     ' + str(np.round(np.mean(B1**2), decimals=3)) + '\n' +
                  'LMLE:   ' + str(np.round(np.mean(B2**2), decimals=3)) + '\n' +
                  'LMLEB: ' + str(np.round(np.mean(B3**2), decimals=3)) + '\n' +
                  'MLEC:   ' + str(np.round(np.mean(B4**2), decimals=3)) + '\n' +
                  'Vcrb MLE: '  + str(np.round(crb_MLE2, decimals=3))  + '\n' +
                  'Vcrb LMLE: ' + str(np.round(crb_LMLE2, decimals=3)) )

        plt.text(0.02, 0.5, textstr, fontsize=12, transform=plt.gcf().transFigure)
        plt.subplots_adjust(left=0.35)

        save=0
        if save:
            file="T" + "_pos_" + str(i) + '.pdf'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20200824/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

def main6():
    a=np.array(range(1000))/999
    k=1
    y=k*(1-16*a**4 + 32*a**3 - 16*a**2)/(4*a*(1-a))

    plt.plot(a,y)
    plt.grid(True)
    plt.show()

def main7():
    """
    LMLE to MLE function 
    """
    k=1
    x=k*((np.array(range(1000))/1000)-0.5)*2
    
    y=(k/2)*np.log( (1-(x/k))/(1+(x/k)) )

    plt.plot(x,y,'b')
    plt.plot(x,2*y,'r')
    plt.plot(x,0.5*y,'g')
    plt.xlabel('x LMLE units of k= sigma^2/alpha')
    plt.ylabel('x MLE units of k= sigma^2/alpha')
    plt.legend(('k=1','k=2','k=0.5'))
    plt.grid(True)

    save=0
    if save:
        file="T" + "_pos_" + str(i) + '.pdf'
        path="C:/Users/elias/Desktop/Shadowfax/Data/20200827/"
        fig.savefig(path + file)
        plt.close()
    else:
        plt.show()

def main8():
    """
    Photon discritation error for MLE  
    Step size MLE(a)-MLE(a) 
    """
    k=1
    p=100
    for N in np.array(range(50))+4:
        N=10
        fig = plt.figure()
        ax0=fig.add_subplot()
        
        a= np.array(range(N*p + 1))/p
    
        #y=-(k/2)*np.log( N/(a*( N-1 -a)) +1 )
        yMLE=(k/2)*np.log( (N/a) - 1 )
        yLMLE=k*(2*(a/N) - 1 )

        for c in [1,2,0.5]:
            ax0.plot(a,c*yMLE,'-b')
            ax0.plot(a[::p],c*yMLE[::p],'r*')
            ax0.plot(a,c*yLMLE,'-m')
            ax0.plot(a[::p],c*yLMLE[::p],'g*')

        ax0.set_xlabel('Photon counts')
        ax0.set_ylabel('x position in units of sigma^2 / alpha')
        ax0.legend(('MLE','MLE points','-LMLE','-LMLE points'))
        ax0.set_title("Total photons N= " + str(N))
        ax0.grid(True)
        ax0.set_ylim(-3, 3)
        
        save=0
        if save:
            file="T" + "_pos_" + str(N) + '.pdf'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20200827/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

def main9():
    """
    Zero truncated distributions
    """
    for i in range(40):
        #i=10
        i=i+1
    
        fig = plt.figure(constrained_layout=True)
        fig.set_size_inches(2*5, 2*5, forward=True)
        gs = GridSpec(2, 2, figure=fig, width_ratios=[3,1], height_ratios=[1, 3])
        ax0=fig.add_subplot(gs[1, 0])
        ax1=fig.add_subplot(gs[0, 0])
        ax2=fig.add_subplot(gs[1, 1])
        ax3=fig.add_subplot(gs[0, 1])

        a=0.8*i
        b=0.2*i
        s=1000000

        #sigma=(0.822/2)*(540e-9 / 1.45) #Beam Gaussian sigma 
        #L=235e-9                        #Beam distance 
        k=1                             # sigma**2/L 

        x=(k/2)*np.log(b/a)
        crb_MLE2 =((k/2)**2)*(a+b)/(a*b)

        na=np.random.poisson(a,s)
        nb=np.random.poisson(b,s)           
        
        #Remove invalid points
        Zero=np.logical_or((na==0),(nb==0))
        na=na[np.invert(Zero)]
        nb=nb[np.invert(Zero)]
    
        #MLE
        xMLE= (k/2)*np.log(nb/na)
        
        #LMLE
        xLMLE = -k*((na-nb)/(na+nb))
        
        ax0.axhline(y=x, color ="green", linestyle ="--")
        ax0.axvline(x=x, color ="green", linestyle ="--")
        ax0.plot(xLMLE,xMLE,'*b')
        ax0.grid(True)
        ax0.set_ylim(-2, 2)
        ax0.set_xlim(-1, 1)
        ax0.tick_params(direction='in', top=True, right=True)
        ax0.set_xlabel('x LMLE')
        ax0.set_ylabel('x MLE')
        ax0.legend(('True pos','True pos','LMLE vs MLE'))

        ax1.hist(xLMLE, 100)
        ax1.set_xlim(-1, 1)
        ax1.grid(True)
        ax1.tick_params(direction='in', labelbottom=False)

        ax2.hist(xMLE, 100, orientation='horizontal')
        ax2.set_ylim(-2, 2)
        ax2.grid(True)
        ax2.tick_params(direction='in', labelleft=False)

        textstr= ('Na,Nb: '   + str(np.round(s, decimals=3))  + ' , Zero: ' + str(np.round(len(np.where(Zero)[0]), decimals=3))  + '\n' +  
                  'a: '   + str(np.round(a, decimals=3))  + '  b: ' + str(np.round(b, decimals=3))  + '\n' +
                  'True: ' + str(np.round(x, decimals=3))     + ', ' + str(np.round(np.sqrt(crb_MLE2), decimals=3)) + '\n' + 
                  'MLE:  ' + str(np.round(np.mean(xMLE), decimals=3))  + '+-' + str(np.round(np.std(xMLE), decimals=3)) + '\n' +
                  'BMLE: ' + str(np.round(np.sqrt(np.mean((xMLE-x)**2)), decimals=3))  + '\n' +
                  'LMLE: ' + str(np.round(np.mean(xLMLE), decimals=3)) + '+-' + str(np.round(np.std(xLMLE), decimals=3)) + '\n' 
                  'BLMLE:' + str(np.round(np.sqrt(np.mean((xLMLE-x)**2)), decimals=3))  + '\n' )

        ax3.text(0.02, -0.02, textstr, fontsize=12)
        ax3.axis('off')


        save=1
        if save:
            file="T" + "_pos_" + str(i) + '.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20200901/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

def main10():

    for step in range(10): 
        fig = plt.figure(constrained_layout=True)
        #fig.set_size_inches(2*5, 2*5, forward=True)
        #gs = GridSpec(2, 2, figure=fig, width_ratios=[3,1], height_ratios=[1, 3])
        ax0=fig.add_subplot()
        #ax1=fig.add_subplot(gs[0, 0])
        #ax2=fig.add_subplot(gs[1, 1])
        #ax3=fig.add_subplot(gs[0, 1])

        N=40
        CRB_MLE=np.zeros(N)
        CRB_LMLE=np.zeros(N)
        std_MLE=np.zeros(N)
        std_LMLE=np.zeros(N)
        R_MLE=np.zeros(N)
        R_LMLE=np.zeros(N)
        a_index=np.zeros(N)
        b_index=np.zeros(N)
        
        for i in range(N):
            i=i+1
    
            a=(0.99 - step/10)*i
            b=(0.01 + step/10)*i
            s=1000000
            a_index[i-1]=a
            b_index[i-1]=b

            #sigma=(0.822/2)*(540e-9 / 1.45) #Beam Gaussian sigma 
            #L=704e-9                        #Beam distance 
            k=1                              # sigma**2/L 

            #True pos and CRB bounds
            x=(k/2)*np.log(b/a)
            CRB_MLE[i-1] =np.sqrt(((k/2)**2)*(a+b)/(a*b))
            CRB_LMLE[i-1] =np.sqrt(((2*k)**2)*(a*b)/((a+b)**3))

            #Draw poisson samples 
            na=np.random.poisson(a,s)
            nb=np.random.poisson(b,s)           
        
            #Remove "invalid" points, zero tuncation assumption  
            Zero=np.logical_or((na==0),(nb==0))
            na=na[np.invert(Zero)]
            nb=nb[np.invert(Zero)]
    
            #MLE
            xMLE= (k/2)*np.log(nb/na)
            std_MLE[i-1]=np.std(xMLE)
            R_MLE[i-1]  =np.sqrt(np.mean((xMLE-x)**2))
        
            #LMLE
            xLMLE = -k*((na-nb)/(na+nb))
            std_LMLE[i-1]= np.std(xLMLE)
            R_LMLE[i-1]  =np.sqrt(np.mean((xLMLE-x)**2))


        ax0.plot(a_index+b_index,CRB_MLE,'-g')
        ax0.plot(a_index+b_index,CRB_LMLE,'--g')
        ax0.plot(a_index+b_index,std_MLE,'-r')
        ax0.plot(a_index+b_index,R_MLE,'--r')
        ax0.plot(a_index+b_index,std_LMLE,'-b')
        ax0.plot(a_index+b_index,R_LMLE,'--b')
        ax0.set_title(('a:' + str(np.round(a_index[0], decimals=3)) + ', b:' + str(np.round(b_index[0], decimals=3)) + ', True pos:' + str(np.round(x, decimals=4)) ))
        ax0.set_xlabel('Ntot = Na + Nb')
        ax0.grid(True)
        ax0.legend(('CRB_MLE','CRB_LMLE','std_MLE','R_MLE','std_LMLE','R_LMLE'))
        ax0.set_ylim(0, 1.5)

        save=1
        if save:
            file="T" + "_pos_" + str(step) + '.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20200902/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

def main11():
    """
    
    """
    for i in range(40):
        #i=10
        i=i+1
    
        fig = plt.figure(constrained_layout=True)
        fig.set_size_inches(2*5, 2*5, forward=True)
        gs = GridSpec(2, 2, figure=fig, width_ratios=[3,1], height_ratios=[1, 3])
        ax0=fig.add_subplot(gs[1, 0])
        ax1=fig.add_subplot(gs[0, 0])
        ax2=fig.add_subplot(gs[1, 1])
        ax3=fig.add_subplot(gs[0, 1])

        a=0.5*i
        b=0.5*i
        s=1000000

        #sigma=(0.822/2)*(540e-9 / 1.45) #Beam Gaussian sigma 
        #L=235e-9                        #Beam distance 
        k=1                             # sigma**2/L 

        x=(k/2)*np.log(b/a)
        crb_MLE2 =((k/2)**2)*(a+b)/(a*b)

        na=np.random.poisson(a,s)
        nb=np.random.poisson(b,s)           
        
        #Remove invalid points where both are zero
        Zero=np.logical_and((na==0),(nb==0))
        na=na[np.invert(Zero)]
        nb=nb[np.invert(Zero)]
    
        #MLE with inf displaced to A
        A=2 # the bound of 2 is past only when we pas photon counts over 55 for k=1 calculation is:  2=k*0.5*ln(N-1) => N=e^(4/k)+1
        ZeroT=np.logical_or((na==0),(nb==0))
        xMLE=np.zeros(na.shape)
        xMLE[np.invert(ZeroT)]= (k/2)*np.log(nb[np.invert(ZeroT)]/na[np.invert(ZeroT)])
        xMLE[ZeroT]=2*(-1)**(nb[ZeroT]==0)
        
        #LMLE
        xLMLE = -k*((na-nb)/(na+nb))
        
        ax0.axhline(y=x, color ="green", linestyle ="--")
        ax0.axvline(x=x, color ="green", linestyle ="--")
        ax0.plot(xLMLE,xMLE,'*b')
        ax0.grid(True)
        ax0.set_ylim(-2, 2)
        ax0.set_xlim(-1, 1)
        ax0.tick_params(direction='in', top=True, right=True)
        ax0.set_xlabel('x LMLE')
        ax0.set_ylabel('x MLE')
        ax0.legend(('True pos','True pos','LMLE vs MLE'))

        ax1.hist(xLMLE, 100)
        ax1.set_xlim(-1, 1)
        ax1.grid(True)
        ax1.tick_params(direction='in', labelbottom=False)

        ax2.hist(xMLE, 100, orientation='horizontal')
        ax2.set_ylim(-2, 2)
        ax2.grid(True)
        ax2.tick_params(direction='in', labelleft=False)

        textstr= ('Na,Nb: '   + str(np.round(s, decimals=3))  + ' , Zero: ' + str(np.round(len(np.where(Zero)[0]), decimals=3))  + '\n' +  
                  'a: '   + str(np.round(a, decimals=3))  + '  b: ' + str(np.round(b, decimals=3))  + '\n' +
                  'True: ' + str(np.round(x, decimals=3))     + ', ' + str(np.round(np.sqrt(crb_MLE2), decimals=3)) + '\n' + 
                  'MLE:  ' + str(np.round(np.mean(xMLE), decimals=3))  + '+-' + str(np.round(np.std(xMLE), decimals=3)) + '\n' +
                  'BMLE: ' + str(np.round(np.sqrt(np.mean((xMLE-x)**2)), decimals=3))  + '\n' +
                  'LMLE: ' + str(np.round(np.mean(xLMLE), decimals=3)) + '+-' + str(np.round(np.std(xLMLE), decimals=3)) + '\n' 
                  'BLMLE:' + str(np.round(np.sqrt(np.mean((xLMLE-x)**2)), decimals=3))  + '\n' )

        ax3.text(0.02, -0.02, textstr, fontsize=12)
        ax3.axis('off')


        save=1
        if save:
            file="T" + "_pos_" + str(i) + '.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20200903/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

def main12():

    for step in range(10): 
        fig = plt.figure(constrained_layout=True)
        #fig.set_size_inches(2*5, 2*5, forward=True)
        #gs = GridSpec(2, 2, figure=fig, width_ratios=[3,1], height_ratios=[1, 3])
        ax0=fig.add_subplot()
        #ax1=fig.add_subplot(gs[0, 0])
        #ax2=fig.add_subplot(gs[1, 1])
        #ax3=fig.add_subplot(gs[0, 1])

        N=40
        CRB_MLE=np.zeros(N)
        CRB_LMLE=np.zeros(N)
        std_MLE=np.zeros(N)
        std_LMLE=np.zeros(N)
        R_MLE=np.zeros(N)
        R_LMLE=np.zeros(N)
        a_index=np.zeros(N)
        b_index=np.zeros(N)
        
        for i in range(N):
            i=i+1
    
            a=(0.99 - step/10)*i
            b=(0.01 + step/10)*i
            s=1000000
            a_index[i-1]=a
            b_index[i-1]=b

            #sigma=(0.822/2)*(540e-9 / 1.45) #Beam Gaussian sigma 
            #L=704e-9                        #Beam distance 
            k=1                              # sigma**2/L 

            #True pos and CRB bounds
            x=(k/2)*np.log(b/a)
            CRB_MLE[i-1] =np.sqrt(((k/2)**2)*(a+b)/(a*b))
            CRB_LMLE[i-1] =np.sqrt(((2*k)**2)*(a*b)/((a+b)**3))

            #Draw poisson samples 
            na=np.random.poisson(a,s)
            nb=np.random.poisson(b,s)           
        
            #Remove "invalid" points, zero tuncation assumption  
            Zero=np.logical_and((na==0),(nb==0))
            na=na[np.invert(Zero)]
            nb=nb[np.invert(Zero)]
    
            #MLE with inf displaced to +-A
            A=2 # the bound of 2 is past only when we pas photon counts over 55 for k=1 calculation is:  2=k*0.5*ln(N-1) => N=e^(4/k)+1
            ZeroT=np.logical_or((na==0),(nb==0))
            xMLE=np.zeros(na.shape)
            xMLE[np.invert(ZeroT)]= (k/2)*np.log(nb[np.invert(ZeroT)]/na[np.invert(ZeroT)])
            xMLE[ZeroT]=2*(-1)**(nb[ZeroT]==0)

            std_MLE[i-1]=np.std(xMLE)
            R_MLE[i-1]  =np.sqrt(np.mean((xMLE-x)**2))
        
            #LMLE
            xLMLE = -k*((na-nb)/(na+nb))
            std_LMLE[i-1]= np.std(xLMLE)
            R_LMLE[i-1]  =np.sqrt(np.mean((xLMLE-x)**2))


        ax0.plot(a_index+b_index,CRB_MLE,'-g')
        ax0.plot(a_index+b_index,CRB_LMLE,'--g')
        ax0.plot(a_index+b_index,std_MLE,'-r')
        ax0.plot(a_index+b_index,R_MLE,'--r')
        ax0.plot(a_index+b_index,std_LMLE,'-b')
        ax0.plot(a_index+b_index,R_LMLE,'--b')
        ax0.set_title(('a:' + str(np.round(a_index[0], decimals=3)) + ', b:' + str(np.round(b_index[0], decimals=3)) + ', True pos:' + str(np.round(x, decimals=4)) ))
        ax0.set_xlabel('Ntot = Na + Nb')
        ax0.grid(True)
        ax0.legend(('CRB_MLE','CRB_LMLE','std_MLE','R_MLE','std_LMLE','R_LMLE'))
        ax0.set_ylim(0, 1.5)

        save=1
        if save:
            file="T" + "_pos_" + str(step) + '.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20200903/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

def main13():

    for step in range(10): 
        fig = plt.figure(constrained_layout=True)
        #fig.set_size_inches(2*5, 2*5, forward=True)
        #gs = GridSpec(2, 2, figure=fig, width_ratios=[3,1], height_ratios=[1, 3])
        ax0=fig.add_subplot()
        #ax1=fig.add_subplot(gs[0, 0])
        #ax2=fig.add_subplot(gs[1, 1])
        #ax3=fig.add_subplot(gs[0, 1])

        N=40
        CRB_MLE=np.zeros(N)
        CRB_LMLE=np.zeros(N)
        std_MLE=np.zeros(N)
        std_LMLE=np.zeros(N)
        R_MLE=np.zeros(N)
        R_LMLE=np.zeros(N)
        a_index=np.zeros(N)
        b_index=np.zeros(N)
        
        for i in range(N):
            i=i+1
    
            a=(0.99 - step/10)*i
            b=(0.01 + step/10)*i
            s=1000000
            a_index[i-1]=a
            b_index[i-1]=b

            #sigma=(0.822/2)*(540e-9 / 1.45) #Beam Gaussian sigma 
            #L=704e-9                        #Beam distance 
            k=1                              # sigma**2/L 

            #True pos and CRB bounds
            x=(k/2)*np.log(b/a)
            CRB_MLE[i-1] =np.sqrt(((k/2)**2)*(a+b)/(a*b))
            CRB_LMLE[i-1] =np.sqrt(((2*k)**2)*(a*b)/((a+b)**3))

            #Draw poisson samples 
            na=np.random.poisson(a,s)
            nb=np.random.poisson(b,s)           
        
            #Remove "invalid" points, zero tuncation assumption  
            Zero=np.logical_and((na==0),(nb==0))
            na=na[np.invert(Zero)]
            nb=nb[np.invert(Zero)]
    
            #MLE with inf displaced to +-A
            A=2 # the bound of 2 is past only when we pas photon counts over 55 for k=1 calculation is:  A=k*0.5*ln(N-1) => N=e^(2*A/k)+1
            ZeroT=np.logical_or((na==0),(nb==0))
            xMLE=np.zeros(na.shape)
            xMLE[np.invert(ZeroT)]= (k/2)*np.log(nb[np.invert(ZeroT)]/na[np.invert(ZeroT)])
            xMLE[ZeroT]=A*(-1)**(nb[ZeroT]==0)

            std_MLE[i-1]=np.std(xMLE)
            R_MLE[i-1]  =np.sqrt(np.mean((xMLE-x)**2))
        
            #LMLE
            xLMLE=np.zeros(na.shape)
            polypower=10
            for exp in range(polypower):
                xLMLE = xLMLE + (k/2)*( (nb/(na+nb))**(exp+1) - (na/(na+nb))**(exp+1))/(exp+1)

            std_LMLE[i-1]= np.std(xLMLE)
            R_LMLE[i-1]  =np.sqrt(np.mean((xLMLE-x)**2))
            print(str(i) + ':' + str(step) )

        ax0.plot(a_index+b_index,CRB_MLE,'-g')
        ax0.plot(a_index+b_index,CRB_LMLE,'--g')
        ax0.plot(a_index+b_index,std_MLE,'-r')
        ax0.plot(a_index+b_index,R_MLE,'--r')
        ax0.plot(a_index+b_index,std_LMLE,'-b')
        ax0.plot(a_index+b_index,R_LMLE,'--b')
        ax0.set_title(('a:' + str(np.round(a_index[0], decimals=3)) + ', b:' + str(np.round(b_index[0], decimals=3)) + ', True pos:' + str(np.round(x, decimals=4)) ))
        ax0.set_xlabel('Ntot = Na + Nb')
        ax0.grid(True)
        ax0.legend(('CRB_MLE','CRB_LMLE','std_MLE','R_MLE','std_LMLE','R_LMLE'))
        ax0.set_ylim(0, 1.5)

        save=1
        if save:
            file="T" + "_pos_" + str(step) + '.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20200903/"
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()

def main14():

    x=(np.array(range(1000))-500)/50
    A=1
    a=0.9
    s=1
    def f(x,a,s,A):
        res=A*(((x-a)**2)/(2*s**2))*np.exp(-(((x-a)**2)/(2*s**2)))
        return res
    
    fm=f(x,a,s,A)
    fp=f(x,-a,s,A)
    fz=f(x,0,s,A)

    gp=fp/(fm+fp+fz)
    gm=fm/(fm+fp+fz)
    gz=fz/(fm+fp+fz)
    
    fig = plt.figure(constrained_layout=True)
    ax0=fig.add_subplot()
    ax0.plot(x,gp,'g-')
    ax0.plot(x,gm,'b-')
    ax0.plot(x,gz,'r-')
    #ax0.plot(x,gm+gp,'r--')
    ax0.plot(x,fm,'b--')
    ax0.plot(x,fp,'g--')
    ax0.plot(x,fz,'r--')
    #ax0.plot(x,(1 + (gp-gm)/(gp+gm))/2,'b--')
    


    #ax0.plot(x,((gp**(0.31))*(gm**(1-2*0.31))*(gz**(0.31)))**10,'m-')
    #for y in range(10):
    #    plt.plot(x,((gp**(y/10))*(gm**(1-(y/10)))*(gz**0.0))**10)
    ax0.grid(True)

    save=0
    if save:
        file="Doughnut_1D_" + '.png'
        path="C:/Users/elias/Desktop/Shadowfax/Data/20200903/"
        fig.savefig(path + file)
        plt.close()
    else:
        plt.show()

def main15():

    for step in range(10): 
        #fig = plt.figure(constrained_layout=True)
        #fig.set_size_inches(2*5, 2*5, forward=True)
        #gs = GridSpec(2, 2, figure=fig, width_ratios=[3,1], height_ratios=[1, 3])
        #ax0=fig.add_subplot()
        #ax1=fig.add_subplot(gs[0, 0])
        #ax2=fig.add_subplot(gs[1, 1])
        #ax3=fig.add_subplot(gs[0, 1])

        N=40
        CRB_MLE=np.zeros(N)
        CRB_LMLE=np.zeros(N)
        std_MLE=np.zeros(N)
        std_LMLE=np.zeros(N)
        R_MLE=np.zeros(N)
        R_LMLE=np.zeros(N)
        a_index=np.zeros(N)
        b_index=np.zeros(N)
        TopHatRange=1.0 - np.array(range(5))/10
        for TopHatCut in TopHatRange:
            fig = plt.figure(constrained_layout=True)
            ax0=fig.add_subplot()
            for i in range(N):
                i=i+1
    
                a=(0.99 - step/10)*i
                b=(0.01 + step/10)*i
                s=1000000
                a_index[i-1]=a
                b_index[i-1]=b

                #sigma=(0.822/2)*(540e-9 / 1.45) #Beam Gaussian sigma 
                #L=704e-9                        #Beam distance 
                k=1                              # sigma**2/L 

                #True pos and CRB bounds
                x=(k/2)*np.log(b/a)
                CRB_MLE[i-1] =np.sqrt(((k/2)**2)*(a+b)/(a*b))
                CRB_LMLE[i-1] =np.sqrt(((2*k)**2)*(a*b)/((a+b)**3))

                #Draw poisson samples 
                na=np.random.poisson(a,s)
                nb=np.random.poisson(b,s)           
        
                #Remove "invalid" points, zero tuncation assumption  
                Zero=np.logical_and((na==0),(nb==0))
                na=na[np.invert(Zero)]
                nb=nb[np.invert(Zero)]
    
                #MLE with inf displaced to +-A
                A=2 # the bound of 2 is past only when we pas photon counts over 55 for k=1 calculation is:  A=k*0.5*ln(N-1) => N=e^(2*A/k)+1
                ZeroT=np.logical_or((na==0),(nb==0))
                xMLE=np.zeros(na.shape)
                xMLE[np.invert(ZeroT)]= (k/2)*np.log(nb[np.invert(ZeroT)]/na[np.invert(ZeroT)])
                xMLE[ZeroT]=A*(-1)**(nb[ZeroT]==0)
                    # Tophat cutoff 
                ToBeCut=np.where(np.abs(xMLE)>TopHatCut)
                xMLE[ToBeCut]=np.sign(xMLE[ToBeCut])*TopHatCut
            
                std_MLE[i-1]=np.std(xMLE)
                R_MLE[i-1]  =np.sqrt(np.mean((xMLE-x)**2))
        
                #LMLE
                xLMLE=np.zeros(na.shape)
                polypower=1
                for exp in range(polypower):
                    xLMLE = xLMLE + (k/2)*( (nb/(na+nb))**(exp+1) - (na/(na+nb))**(exp+1))/(exp+1)

                std_LMLE[i-1]= np.std(xLMLE)
                R_LMLE[i-1]  =np.sqrt(np.mean((xLMLE-x)**2))
                print(str(i) + ':' + str(step) )

            ax0.plot(a_index+b_index,CRB_MLE,'-g')
            ax0.plot(a_index+b_index,CRB_LMLE,'--g')
            ax0.plot(a_index+b_index,std_MLE,'-r')
            ax0.plot(a_index+b_index,R_MLE,'--r')
            ax0.plot(a_index+b_index,std_LMLE,'-b')
            ax0.plot(a_index+b_index,R_LMLE,'--b')
            ax0.set_title(('a:' + str(np.round(a_index[0], decimals=3)) + ', b:' + str(np.round(b_index[0], decimals=3)) + ', True pos:' + str(np.round(x, decimals=4)) ))
            ax0.set_xlabel('Ntot = Na + Nb')
            ax0.grid(True)
            ax0.legend(('CRB_MLE','CRB_LMLE','std_MLE','R_MLE','std_LMLE','R_LMLE'))
            ax0.set_ylim(0, 1.5)

            save=1
            if save:
                file="T" + "_pos_" + str(step) + '_THatCut_' + str(TopHatCut) + '.png'
                path="C:/Users/elias/Desktop/Shadowfax/Data/20200903/Variationplot_tophatcut/" + "A" + str(TopHatCut) + "/"
                fig.savefig(path + file)
                plt.close()
            else:
                plt.show()

def main16():
    #Gaussian offseted and unbalanced 

    for i in range(20):
        x=(np.array(range(1000))-500)/50
        alpha=2 #Displacment from origo 
        sigma=1 #Gaussian width 
        A1=1; B1=0.1*i 
        A2=0.5; B2=0.1*i
        truncation=0.00000001
        k=1.5* sigma**2 / alpha #Tophat prior / tracking area ich
        A3=0.5 #Second bump on F2, hight compared to 1-truncation

        F1=np.exp( -((x+alpha)**2)/(2*sigma**2) )-truncation
        F1[F1<0]=0
        F1=A1*F1+B1

        F2=np.exp( -((x-alpha)**2)/(2*sigma**2) )-truncation
        F2[F2<0]=0
        F2= A2* (F2+A3*np.exp( -((x+1.5)**2)/(2*sigma**2) )) + B2 #2.5

        G1=F1/(F1+F2)
        G2=F2/(F1+F2)

        fig = plt.figure()
        gs0 = gridspec.GridSpec(2, 2, figure=fig)

        ax0=fig.add_subplot(gs0[:,0])
        ax1=fig.add_subplot(gs0[0,1])
        ax2=fig.add_subplot(gs0[1,1])

        points=10
        if i==0:
            x0=np.zeros(points)
            LM0=np.zeros(points)
            Ry=np.zeros(points)

        xLM1=np.zeros(points)
        LM1=np.zeros(points)
        xLM2=np.zeros(points)
        LM2=np.zeros(points)
        LM2arg=np.zeros(points).astype('int')
        for j in range(points):
            Ry[j]=(0.05+j/points)
            L=(G1**(Ry[j]))*(G2**(1-Ry[j]))
            L[np.where(np.isnan(L))]=0
            LMarg1=np.argmax(L)
            xLM1[j]=x[LMarg1]
            LM1[j]=L[LMarg1]
            
            ax0.plot(x,L,'g')
            
            L[np.where(np.abs(x)>k)]=0
            LMarg2=np.argmax(L)
            LM2arg[j]=LMarg2
            xLM2[j]=x[LMarg2]
            LM2[j]=L[LMarg2]

            if i==0:
                x0[j]=x[LMarg2]
                LM0[j]=L[LMarg2]

        ax0.plot(xLM1,LM1,'r*')    
        ax0.plot(xLM2,LM2,'-b*')    
        ax0.plot(x0,LM0,'-m*')    
        ax0.set_xlim((-5,5))
        ax0.axes.yaxis.set_ticks([])
        ax0.set_xticks((-k,k), minor=True)
        ax0.grid(which='minor', alpha=0.2)
        ax0.grid(which='major', alpha=0.5)

        ax1.plot(x,F1/np.max((F1,F2)),'r');ax1.plot(x,F2/np.max((F1,F2)),'b')
        ax1.plot(x,(F1+F2)/np.max((F1,F2)),'y')
        ax1.plot(x[LM2arg],(F1/np.max((F1,F2)))[LM2arg],'r*'); ax1.plot(x[LM2arg],(F2/np.max((F1,F2)))[LM2arg],'b*')
        ax1.legend(("SNB: " +str(np.round(np.max(F1)/B1, decimals=2)), "SNB: " +str(np.round(np.max(F2)/B2, decimals=2)), "Tot photons" )) 
        ax1.set_title("PSF")
        ax1.set_ylim((0, np.max( ( F1/np.max((F1,F2)),F2/np.max((F1,F2)),(F1+F2)/np.max((F1,F2)) ) ) ))
        ax1.set_xlim((-5,5))
        ax1.axes.xaxis.set_ticks([])
        ax1.grid(True)

        ax2.plot(x,G1,'r'); ax2.plot(x,G2,'b')
        ax2.plot(x[LM2arg],G1[LM2arg],'r*'); ax2.plot(x[LM2arg],G2[LM2arg],'b*')
        ax2.set_title("coefficients")
        ax2.set_xlim((-5,5))
        ax2.set_ylim((0,1))
        ax2.set_yticks(Ry, minor=True)
        ax2.set_xticks((-k,k), minor=True)
        ax2.grid(which='minor', alpha=0.2)
        ax2.grid(which='major', alpha=0.5)
        ax2.set_xlabel('x')

        save=1
        if save:
            file="T" + "_pos_" + str(i) + '.png'
            path="C:/Users/elias/Desktop/Shadowfax/Data/20201012_(SIM_PSF_SNB_Offset_Likelihood_stability_Tophat_1D)/test/" 
            fig.savefig(path + file)
            plt.close()
        else:
            plt.show()
               
def main17():
    #Gaussian offseted and unbalanced 
    noisepoints=10
    separationpoints=10

    dalpha=np.zeros((noisepoints,separationpoints))
    SNB=np.zeros((noisepoints,separationpoints))
    for i in range(noisepoints):
        for separation in range(separationpoints):
            x=(np.array(range(1000))-500)/50
            alpha=0.5+2.5*separation/separationpoints #Displacment from origo 
            sigma=1 #Gaussian width 
            A1=1; B1=0.1*i 
            A2=1; B2=0.1*i
            truncation=0.00000001
            k=1.5* sigma**2 / alpha #Tophat prior / tracking area ich
            A3=0 #Second bump on F2, hight compared to 1-truncation

            F1=np.exp( -((x+alpha)**2)/(2*sigma**2) )-truncation
            F1[F1<0]=0
            F1=A1*F1+B1

            F2=np.exp( -((x-alpha)**2)/(2*sigma**2) )-truncation
            F2[F2<0]=0
            F2= A2* (F2+A3*np.exp( -((x+1.5)**2)/(2*sigma**2) )) + B2 #2.5

            G1=F1/(F1+F2)
            G2=F2/(F1+F2)

            fig = plt.figure()
            gs0 = gridspec.GridSpec(2, 2, figure=fig)

            ax0=fig.add_subplot(gs0[:,0])
            ax1=fig.add_subplot(gs0[0,1])
            ax2=fig.add_subplot(gs0[1,1])

            points=2
            if i==0:
                x0=np.zeros(points)
                LM0=np.zeros(points)
                Ry=np.zeros(points)

            xLM1=np.zeros(points)
            LM1=np.zeros(points)
            xLM2=np.zeros(points)
            LM2=np.zeros(points)
            LM2arg=np.zeros(points).astype('int')
            for j in range(points):
                Ry[j]=(0.45+j*(0.1))
                L=(G1**(Ry[j]))*(G2**(1-Ry[j]))
                L[np.where(np.isnan(L))]=0
                LMarg1=np.argmax(L)
                xLM1[j]=x[LMarg1]
                LM1[j]=L[LMarg1]
            
                ax0.plot(x,L,'g')
            
                L[np.where(np.abs(x)>k)]=0
                LMarg2=np.argmax(L)
                LM2arg[j]=LMarg2
                xLM2[j]=x[LMarg2]
                LM2[j]=L[LMarg2]

                if i==0:
                    x0[j]=x[LMarg2]
                    LM0[j]=L[LMarg2]
        

            # calculating angle
            dx=np.diff(x[LM2arg]) 
            dG1=np.arctan(np.diff(G1[LM2arg])/dx)
            dG2=np.arctan(np.diff(G2[LM2arg])/dx)
            dalpha[i,separation]=dG2-dG1
            SNB[i,separation]=np.round(np.max(F1)/B1)

            ax0.plot(xLM1,LM1,'r*')    
            ax0.plot(xLM2,LM2,'-b*')    
            ax0.plot(x0,LM0,'-m*')    
            ax0.set_xlim((-5,5))
            ax0.axes.yaxis.set_ticks([])
            ax0.set_xticks((-k,k), minor=True)
            ax0.grid(which='minor', alpha=0.2)
            ax0.grid(which='major', alpha=0.5)

            ax1.plot(x,F1/np.max((F1,F2)),'r');ax1.plot(x,F2/np.max((F1,F2)),'b')
            ax1.plot(x,(F1+F2)/np.max((F1,F2)),'y')
            ax1.plot(x[LM2arg],(F1/np.max((F1,F2)))[LM2arg],'r*'); ax1.plot(x[LM2arg],(F2/np.max((F1,F2)))[LM2arg],'b*')
            ax1.legend(("SNB: " +str(np.round(np.max(F1)/B1, decimals=2)), "SNB: " +str(np.round(np.max(F2)/B2, decimals=2)), "Tot photons" )) 
            ax1.set_title("PSF")
            ax1.set_ylim((0, np.max( ( F1/np.max((F1,F2)),F2/np.max((F1,F2)),(F1+F2)/np.max((F1,F2)) ) ) ))
            ax1.set_xlim((-5,5))
            ax1.axes.xaxis.set_ticks([])
            ax1.grid(True)

            ax2.plot(x,G1,'r'); ax2.plot(x,G2,'b')
            ax2.plot(x[LM2arg],G1[LM2arg],'r*'); ax2.plot(x[LM2arg],G2[LM2arg],'b*')
            ax2.set_title("coefficients")
            ax2.set_xlim((-5,5))
            ax2.set_ylim((0,1))
            ax2.set_yticks(Ry, minor=True)
            ax2.set_xticks((-k,k), minor=True)
            ax2.grid(which='minor', alpha=0.2)
            ax2.grid(which='major', alpha=0.5)
            ax2.set_xlabel('x')

            save=1
            if save:
                file="T" + "_pos_" + "noise_" + str(i) + "_sep_" + str(separation) + '.png'
                path="C:/Users/elias/Desktop/Shadowfax/Data/20201012_(SIM_PSF_SNB_Offset_Likelihood_stability_Tophat_1D)/test/" 
                fig.savefig(path + file)
                plt.close()
            else:
                plt.show()
    
    for i in range(dalpha.shape[1]): 
        plt.plot(dalpha[:,i])
    plt.grid()
    plt.show()

    print("done")

if __name__ == '__main__':
    main17()

    """
    x=2*(np.array(range(1000))-0)/500
    y1=np.abs(x/(2-x**2))
    y2=1/x
    plt.plot(x,y1,'g-')
    plt.grid(True)
    plt.plot(x,y2,'b-')
    plt.ylim(-20, 20)
    plt.show()
    """



    """
    x=(np.array(range(1000))-500)/500
    y1=(2+2*x)**(-1)
    y2=(2-2*x)**(-1)
    plt.plot(x,y1,'r')
    plt.plot(x,y2,'b')
    plt.plot(x,y1**(0.8)*y2**(0.2),'g')
    plt.grid(True)
    plt.show()
    """

    
