from pyqtgraph.Qt import QtCore, QtGui
import pyqtgraph.opengl as gl
import numpy as np

class QTgraphPlotLib:
    def DensityPlot(xyz_pos, rgba):
        """
        xyz_pos list of position 
        rgba color of each positon
        """
        app = QtGui.QApplication([])
        w = gl.GLViewWidget()
        w.show()
        g = gl.GLGridItem()
        w.addItem(g)

        sp2 = gl.GLScatterPlotItem(pos=xyz_pos,color=rgba,size=0.4)
        w.addItem(sp2)        

        #Start the QT loop
        QtGui.QApplication.instance().exec_()


    def DensityPlot_test():       
        app = QtGui.QApplication([])
        w = gl.GLViewWidget()
        w.show()
        g = gl.GLGridItem()
        w.addItem(g)

        #generate random points from -10 to 10, z-axis positive
        pos = np.random.randint(-10,10,size=(1000,3))
        pos[:,2] = np.abs(pos[:,2])

        sp2 = gl.GLScatterPlotItem(pos=pos)
        w.addItem(sp2)

        #generate a color opacity gradient
        color = np.zeros((pos.shape[0],4), dtype=np.float32)
        color[:,0] = 1
        color[:,1] = 0
        color[:,2] = 0.5
        color[0:100,3] = np.arange(0,100)/100.
        sp2.setData(color=color)

        ## For animation 
        #t = QtCore.QTimer()
        #t.timeout.connect(update)
        #t.start(50)

        #start the QT loop 
        QtGui.QApplication.instance().exec_()


    def update():
        # For animation the needs to be modifyed
        ## update volume colors
        global color
        color = np.roll(color,1, axis=0)
        sp2.setData(color=color)



## test enviroment 
if __name__ == '__main__':
    #QTgraphPlotLib.DensityPlot_test()
    xyz_pos=np.array([[0,1,2,3,4,5,6,7,8,9],[0,1,2,3,4,5,6,7,8,9],[0,1,2,3,4,5,6,7,8,9]])
    xyz_pos=np.transpose(xyz_pos)
    rgba=np.array([[0,1,2,3,4,5,6,7,8,9],[0,1,2,3,4,5,6,7,8,9],[0,1,2,3,4,5,6,7,8,9],[0,1,2,3,4,5,6,7,8,9]])/9.0
    rgba=np.transpose(rgba)
    QTgraphPlotLib.DensityPlot(xyz_pos, rgba)
