import numpy as np
from skimage import io
from matplotlib import pyplot as plt
from img_slice_viewer import IndexTracker

# used to check that the stack was loaded correctly
# def check_stack(image):
#     print(image.shape)
#     fig, ax = plt.subplots(1, 1)
#     tracker = IndexTracker(ax, image)
#     fig.canvas.mpl_connect('scroll_event', tracker.onscroll)
#     plt.show()

def Main():
    time_points = 15
    delta_z = 0.025*2 # um
    # load, reshape, and average (uncomment check_stack to see if loaded properly)
    mydir = 'C:\\Users\\shadowfax-camera\\Documents\\PSF stacks\\20210115\\alignment\\'
    myfile = 'staircase'
    im = io.imread(mydir + myfile + '_MagellanStack' + '.tif')
    # check_stack(im)
    im_tzyx = im.reshape((time_points,int(im.shape[0]/time_points),im.shape[1],im.shape[2]), order='F')
    # print(im_tzyx.shape)
    im_zyx = np.mean(im_tzyx, axis=0)
    # check_stack(im_zyx)

    # find the brightest voxels and plot z-axis profile
    spot_num = 3
    radius = 6 # pixels
    z = np.arange(im_zyx.shape[0])*delta_z # convert to um
    z_profiles = np.zeros((im_zyx.shape[0],spot_num))
    # z_range = int(0.6/delta_z) # pixels
    for i in range(spot_num):
        zmax, ymax, xmax = np.unravel_index(np.argmax(im_zyx), im_zyx.shape)
        z_profiles[:,i] = im_zyx[:,ymax,xmax]
        plt.plot(z,z_profiles[:,i]) 
        # plt.plot(z[zmax-z_range:zmax+z_range],z_profiles[zmax-z_range:zmax+z_range,i])
        im_zyx[:, ymax-radius:ymax+radius, xmax-radius:xmax+radius] = 0

    plt.savefig(mydir + myfile + '_plot.tif')
    plt.show()


if __name__=='__main__':
    Main()